% プロファイリング



スケールバーの自動生成は
jpegファイル内に含まれているフォーカス情報を元に処理を行います。
その処理のために必要なパラメタを求める作業をプロファイリングと呼んでいます。

コンパクトデジタルカメラの場合機種ごとにプロファイリングを行う必要があります。
フォーサーズ機とマイクロフォーサーズ機はひとまとめにして良さそうなので、
レンズごとにプロファイリング作業が必要になります。

もしプロファイリングを行ったらそのデータを
私宛に送っていただければシステムに組み込みたいと思います。
よろしくお願いします。


### TODO

ズームレンズはあまり正確には測れない。

単焦点も
マクロレンズで1/8ぐらい?

無限遠
 -f999999


ズーム倍率という用語はおかしい？
おかしい








ズームレンズの場合の注意点
 
表示倍率


<div class="toc">
* 1 はじめに

</div>



## 1. はじめに

おおまかな作業の流れは以下のとおりです。

* ゲージ(黒と白の帯が等間隔に並んだもの)を条件を変えて複数枚撮影する。
* 撮影した画像ファイルをプロファイラソフトに食わせる。
* プロファイラでAnalizeを行うと自動的に処理される。
* プロファイラでExportを行うファイルを作成する。


ゲージは後述しますがJavascriptアプリケーションで、
スマホやパソコンのディスプレイを使って表示します。

プロファイラもJavascriptアプリケーションです。パソコンで動かします。




### 1.0 必要なもの

* ゲージ表示用のスマホまたはパソコンのディスプレイ
* パソコン
 プロファイリングツールはjavascriptで書かれておりブラウザ上で動作しますが、
 大きめのディスプレイとマウスとキーボードの使用を想定しています。
* 三脚
* 微動装置(安物で良い)


ゲージ表示用のディスプレイは、
高倍率の場合スマホの方がピッチが細かいので有利です。
パソコンのディスプレイはピッチが荒く、
またノングレア処理されているとぼやけるため使えません。


微動装置は




### 1.1 フォーカス情報の確認

最初に、対象となるカメラで保存したjpegファイルに
フォーカス情報がしまわれているかどうか確認してください。
これが保存されていないと話になりません。

画像編集ソフトを通したものは
フォーカス情報が失われている可能性が高いので
カメラが保存したjpegファイルをそのまま使ってください。

Scabarで File -> Image Info. を開き以下の項目が表示されていればOKです。

* Focus Step Count

もしくはProfilerで
読み込んでFSC欄が表示されていればOK。



### 1.1 用語

FOV

: Field Of View の略です。実視野。
 一般的には角度の意味で使われることもありますが、
 Scabarではピントがあっている物体面の矩形の長辺の長さとします。
 →イメージセンサーの横幅に対応する...


FOV プロファイル

: フォーカス情報からFOVを求めるためのパラメタです。
 一般用語ではありません。

Focus Step Count

: jpegファイル内に保存されているフォーカス情報です。
 一般用語ではなく、ExifToolというソフトが使用している用語です。
 FSCと略すことがあります。
 編集ソフトなどを通すと失われます。

Zoom Step Count

: jpegファイル内に保存されているズーム情報です。
 一般用語ではなく、ExifToolというソフトが使用している用語です。
 ZSCと略と略すことがあります。
 編集ソフトなどを通すと失われます。
 値は整数でカメラのモニタ画面に表示される焦点距離と対応しています。




## 1.2 作業の流れ

* 基準ゲージ(定規みたいなもの)を用意する
* 撮影距離、ズーム比を変えて写真を撮影する
* 画像ファイルの名前を変更する
* profiler.htmlを起動
* 画像を開く/ドロップ
* 解析開始
* グラフをチェック
* 結果をExport
* Scabarに取り込む




## 2. 基準ゲージ

FOVは長さが既知の物体を撮影することで
求めることができますが、
自動で処理するために
白背景に黒の縦棒が等間隔でならぶパターンを使います。
液晶ディスプレイを使うと
細かいピッチにでき、
精度も高そうですし、大きさも自在にできるし、
ゴミもでないしと具合が良さそうです。
そのためのツールを作ったのでご利用ください。


### 2.1 起動

スマホかパソコンで以下のページを表示してください。
スマホの方がピッチは細かいです。
ノングレア処理されたディスプレイでは
ぼやけて見えるので高倍率の場合は適していません。

**ブラウザの表示倍率を100%にしてください**

<div class="menu">
[基準ゲージ表示ツール(gauge.html)](gauge.html)
</div>

スクリーンショットです。
スクロールすれば全体にパターンが表示されます。
汚らしい感じですがオートフォーカスを利かせるため
ランダムパターンを混ぜ込んであります。
色の付いた線は傾いたりしていないかを確認するためのものです。

![基準ゲージ表示ツール](image/profiler-12.png)




### 2.2 動作確認

虫眼鏡等を用いてドット単位で線が描かれているか確認してください。
以下のように１ピクセルおきに線が引かれていれば大丈夫です。

アナライザはRGBのうち最大輝度のコンポーネントを使用して処理するので、
白と黒の帯として処理されています。
中央に輝度の低い部分がありますが、ある程度エラーを吸収できるので
これくらいだと問題ありません。


![パターンの拡大図](image/profiler-11.jpg)



### 2.3 スクリーンサイズの入力

スクリーンの幅をwの欄にmm単位で入力してください。
どっちが幅かわからない場合もあるかもしれませんが、
自動計算しているhの欄を見て確認してください。


### 2.4 ピッチの変更

定規などで測ってピッチが正常か確認してください。
一番上のボタン1,2,4...で、ピッチを広くしたり狭くしたりすることができます。



## 3. 撮影


**ご注意**
スマホの近くでフラッシュを焚くとスマホにダメージを与えるかもしれません。
フラッシュはオフにしておいたほうが良いと思います。


モードごとに
顕微鏡モード



撮影距離と焦点距離(ズーム倍率)を少しずつ変えて基準ゲージを複数枚撮影します。

どのような

撮影距離、焦点距離(ズーム倍率)、基準ゲージのピッチは
忘れないように記録してください。



### カメラの設定

* GPS位置情報記録オフにする
 公開される可能性がある場合オフにしてください。
 そうしないと撮影場所が特定されてしまいます。

* 公開用の場合、解像度を少し下げる
 それほど解像度は必要ないので、
 3200x2400 pixel の 圧縮率も標準以下

* アスペクト比
 クロッピングされていない状態にする。
 オリンパスの場合たぶん4:3。
 チェック

* 露出補正 +0.3〜+0.7 ぐらい?

* フラッシュを発行禁止に

* FD-1やLD-1を外して標準のリングに戻す。
 できるだけ最大

* 手ぶれ補正OFF

* デジタルズームは無しに
　Exifから

* 絞り
　なるべく開く！



### 焦点距離(ズーム倍率)の選択



TGシリーズの場合


単焦点レンズの場合


ズームレンズの場合







### 3.1 撮影モードの選択

ここで撮影モードというのは遠景/マクロのどちらかのことです。


撮影モードが複数ある場合は、それぞれ別にプロファイリングを行ってください。
例えばTG-5の場合、遠景モードとマクロモードで
2回プロファイリングを行い、2つのプロファイルデータを作る必要があります。
フォーサーズ機 + 35mm F3.5 Macro では、マクロも遠景も区別はありませんので
1回プロファイリングを行います。

TG-5の場合、A/Pモードが遠景モード、顕微鏡モードがマクロモードです。
顕微鏡モードは4つのサブモード(顕微鏡、 深度合成、 フォーカスBKT、
顕微鏡コントロール(顕微鏡+デジタルズーム))がありますが、
プロファイリングは『顕微鏡』を使ってください。




### 3.1 撮影距離の選択


### ピントリングがあるレンズの場合

ピントリングを等間隔に回す。

無限遠(もしくは最も遠い位置)
1とすると、

 4/4, 3/4, 2/4, 1/4, 0(*)

0は

0が無限遠になる場合は、
0
 1/8あたり


クリック


### ピントリングがない場合

TG-5など









倍率がおおむね等間隔になるように撮影距離を選択してください。

 0.25/n*m,  1/n*m, 2/n*m, .... n*/n*m

 m: 最大倍率
 n: 適当な分割(4〜6ぐらい)



大体で良いので、


インナーフォーカスの場合は、高倍率側を少し細かくしたほうが良さそうです。





ここではレンズ前からゲージまでの距離を撮影距離とします。

倍率の選択


距離をどのように選択するかは自由ですが、

おおむね

最大倍率をMとすると、

等分して
5
 1/16

ような撮影距離





インナーフォーカスの場合は

ズームの場合





#### 単焦点レンズの場合


#### 


 1
 1.4

### 3.2 焦点距離(ズーム倍率)の選択


ピントが合わない場合

最低2点ないとまずい...



### 3.3 基準ゲージの設定

RAW画像から静止したjpegファイルや
編集ソフトを通したjepgeファイルでは
おそらくフォーカス情報が失われると思います。
jpegで撮影した画像をそのまま使ってください。


利用部分は写真の中心部の縦10%、横50%の範囲です。
この範囲に基準ゲージが含まれるようにしてください。

基準ゲージのバーの本数は
少ないと

線幅
画面上部にある1〜32の番号のついたボタンで線幅を指定してください。
撮影画面内に全体に10本から100本ぐらいの線が含まれるようにしてください。





### 3.4 オートフォーカス

基準ゲージはすこし薄汚く見えますが、
オートフォーカスで有利なように
ランダムなパターンを入れてあります。

場合も帯が水平になるように


    RGBRGBRGB

    RGBRGBRGB


    R R
    G G
    B B



単純な繰り返しパターンはオートフォーカスに向かないようです。

TG-5の場合は一度あわせれば大丈夫でしたので、
最初にマニュアルである程度合わせてから


あるいはオートーフォーカスで
ピントがあった位置から少しずつ近づけていくなどすれば
よさそうです。


E-410+35mm Macroでは
(ミラー機)
ではオートフォーカスはつかませんでした。



レンズとゲージの間隔を固定し


ピッチを記録しておいてください。



### 3.5 露出設定

その他
画像の品質

jpeg


絞りはピントが合っているかどうか後で見てわかりやすいので
開放近くが良いと思います。


露出
kkkkkkk
露出補正は+1EVあたりが良さそうでした。


ピント合わせ


シャッター


傾いていないか
2秒タイマー




## 4. ファイル名の変更

ファイル名にいくつかの情報をしまうことにしました。

 d{num}}-p{num}-z{num}.{ext}

{num}の部分には数値を指定します。小数点は'_'に置き換えてください。
 先頭に複数の0を付加してもかまいません。

{ext}は拡張子で'jpg'|'jpeg'です。

大文字でも小文字でもかまいません。

順序は異なっていてもかまいません。

例

* d5-p1_25-z2_1.jpg
* z100-d24-p0_125.jpg


-d{num}

: レンズ前からゲージまでの距離やピントリングの回転角を指定します。
 絶対値は重要ではなくて、順序が重要です。
 距離が長くなるほど大きい数値にしてください。

-z{num}

: ズーム倍率や焦点距離を指定します。
 ズームレンズでない場合は不要です。
 実際には値には意味がなくファイル名を別にするくらいの意味しかありませんので、
 任意の数値でもかまいませんが、

-p{num}

: 基準ゲージのピッチをmm単位で正確に指定してください。
 精度は4桁ぐらいあれば良いかと思います。




## 5 profiler



### 5.1 起動

こちらから起動できます。



### 5.2 画面の説明

![](image/profiler-1.png)

メニュー・情報ペイン

ファイル一覧ペイン

プレビューペイン

グラフペイン


メニュー

![](image/profiler-2.png)


### 5.3 手順

#### ファイルの追加

メニューから'Add Files'を選ぶとファイル選択ダイアログが出るので
追加するファイルを選んでください。複数選択できます。
もしくはファイル一覧ペインにファイルをドラッグ＆ドロップしてもOKです。
ファイルを追加すると
しばらくExif情報を取り込むためファイル情報ペインの表示が更新されますので、
終わるのを待ってください。


#### 解析

Menu → 'Start Analizing'を選ぶと解析が始まります。
解析中はプレビューペイントグラフが更新されます。
途中で中断したい場合は、Menu →'Stop Analizing'を選ぶと中断します。

※表示が更新されない？





### 5.4 パラメタの入力

#### Attachment

自動的に識別できない装置(クローズアップレンズなど)は、
手動で選択することができます。
これを識別するための情報がAttachmentです。
フリーフォーマットで任意の文字を使えます。
文字列はプロファイルを識別するIDの一部となるため、
例えば、同じクローズアップレンズを使うけどセッティングが少し違っている場合、
Attachment文字列を別の値にしておけば、
選択可能になります。

例えばDCR-250を使うけど、
主レンズとの距離が違うような場合、
 
* DCR-250/20mm
* DCR-250/50mm

などとしておくと良いです。
※たぶんこの例だと分けるほどの差は出ないかもしれませんが。


#### Zoom Curve

ズームレンズの場合に指定します。

補間方法に関する指定なので、
すべてのズーム倍率で計測した場合は指定しなくてもかまいません。

選択肢の'liner'と'log'のうち、
2つ目のグラフ'2. Magnification(35mm equiv.) vs. Zoom Step Count'が
直線に近い方を選んでください。



#### Description

Scabarのプロファイル一覧に表示される文字列です。




### 5.5 プレビュー・ペイン

ファイル名、元画像、解析結果が表示されます。
解析に使用されるのは画像の中央部です。
水色の点がそれぞれの黒帯の中にあって、
おおむね揃っていればOKです。

![](image/profiler-3.png)



### 5.6 グラフ・ペイン

#### (1) Magnification(35mm equiv.) vs. Focus Position

横軸がフォーカス位置で縦軸は撮影倍率(35m版相当)です。
フォーカス位置はExif内にあるFocus Step Countをもとにしています。

このグラフはおおむね直線に近くなるはずなので、それを確認してください。

薄いレンズの理論ではこの関係は線形になるはずです。
下はZD 35mm F3.5 Macroで、たぶん全群繰り出し型なのでほぼ直線になっています。

![](image/profiler-5.png)


#### (2) Magnification(35mm equiv.) vs. Zoom Step Count

ズームレンズの場合に表示されます。

情報ペインにあるZoom Curveの指定で結果が変わります。

このグラフが直線に近い方を選んだほうが誤差が少なくなります
(少ないサンプリングで同じ精度が出ます)。
すべてのズーム倍率で測定している場合は補間されないので
どちらを選んでもかまいません。

こちらはZoom Curve = 'log'としたものです。
ほぼ直線になっているのでTG-5の場合は'log'とした方が良いですが、
このようにすべてのズーム位置で測定した場合はどちらでもかまいません。


![](image/profiler-7.png)



#### (3) Focus Position vs. Zoom Step Count

ズームレンズの場合に表示されます。

これも線形補間されるため
曲線の具合によって
サンプリングを増やす必要があります。
全ZSCで測定した場合は関係ありません。

下はTG-5の顕微鏡モードの場合です。

![](image/profiler-8.png)



### 5.7 export





## 6 例


### 6.1 TG-5

通常モード(A/S/P)と顕微鏡モードの２つのモードで
プロファイルを作成する必要があります。

顕微鏡コントロールはデジタルズーム併用なので
これは自動的に処理されます。

TG-4以前は超解像ズームというのがあったようなのですが、
これもデジタルズームの一種なのでおそらく


#### サンプリングポイントの選択

TGシリーズのように焦点距離を変えても
レンズが伸縮しないタイプのレンズの場合、


オートフォーカス

標準のリングで輪ゴムなどでくっつける。

縦、カメラを横
写真


> 距離を変える
>> ズーム位置を変える
> ほげげ

位置を固定


　　






#### グラフ1

下のグラフはTG-5の顕微鏡モードです。
zはズーム倍率のExif内にある情報で、z=4が1.2倍、z=21が4倍に対応しています。
TG-5の場合はインナーフォーカスなので少し曲がってます。

![](image/profiler-4.png)


#### グラフ2

下の2つのグラフはTG-5の顕微鏡モードです。

こちらはZoom Curve='linear'としたものです。

![](image/profiler-6.png)


こちらはZoom Curve = 'log'としたものです。
ほぼ直線になっているのでTG-5の場合は'log'とした方が良いですが、
このようにすべてのズーム位置で測定した場合はどちらでもかまいません。


![](image/profiler-7.png)


#### グラフ3

下はTG-5の顕微鏡モード

![](image/profiler-8.png)




### 6.2 ZD 35mm F3.5 macro (単焦点レンズ)

フォーサーズ用のレンズですが
MMF-3経由でマイクロフォーサーズ機で使った場合も
フォーカス情報がしまわれるようなので
スケールバーの自動生成可能です。

マクロレンズはレンズに倍率が刻印されているので、
全移動量をn等分に選ぶと良いと思います。
以下の例は4等分にしました。
倍率にすると 1, 3/4≒1/1.33, 1/2, 1/4, 0です。
このレンズはおそらく全群繰り出し型で単純な関係なので、
もう少し少ないサンプリング点数でも大丈夫そうです。

![](image/profiler-5.png)



### 6.3 望遠ズームレンズ

向いてないです。

テレ端




### 6.4 望遠レンズ + クローズアップレンズ


下のグラフは望遠レンズにクローズアップレンズ(DCR-250)を付けた場合です。

![](image/profiler-9.png)


下のグラフは、MZD 75-300mm F

![](image/profiler-10.png)


下のグラフは、MZD 75-300mm F

![](image/profiler-10.png)



## 6. Scabarでの操作

Scabarのメニュー Tool → FOV → Manage → Importで
プロファイルデータを取り込むことができます。


Camera+Lens+Extender+Mode

Attachmentに関しては自動認識できないので、
マニュアルで選択する必要があります。


### 6.1 管理

#### Import

追加します。


#### Reset

Importされたものをすべて削除して
出荷状態にもどします。
 

#### Clear

組み込みのプロファイルも削除します。



### 6.2 Profileの選択

Attachmentで自動認識できない機材(クローズアップレンズ等)を指定できますが、
複数ある場合はメニューから選択してください。
 
Tool → FOV → Profile










 





