(function(){
 'use strict'
/*

 fp-detectってなんだっけ?
  prof-analizer


 名前を整理
 プール
 エラーとか
*/
 const Ld = sLoader;
 Ld.module('fp-detect',function(){
  const FpDetect = {};

//
  const rBlurV = 20;
  const rBlurH = 2;

  const EDGE_DETECT_COUNT = 3;
  const PITCH_ERROR_LIMIT       = 0.05;         // %
  const EDGE_ERROR_LIMIT        = 2;

  const N_ROW = 10;
   // N_AVERAGE


  FpDetect.detect = function(imgGray,w,h,pitch,imageWidth){
   let res = {};
   try{

    // !!プール
    let imgBlur = new Array(w*h);
    let imgTmp = new Array(w*h);


    horizBlur(imgGray,imgTmp,w,h,rBlurH);
    vertBlur(imgTmp,imgBlur,w,h,rBlurV);
    let img = imgBlur;

    // detect edge
    let edges = [];
    let bwlist = [];
    {
     let threshold = levelDetect(img,w,h);
     if ( threshold.high <= threshold.low ) { return; }
      // 
     let ystep = (h - 2*rBlurV)/(N_ROW-1);
     for( let i = 0; i < N_ROW; i++ ) {
      let y = rBlurV + Math.round(i*ystep);
      let row = edges[i] = [];
      let x = 0;
      for( ; x < w && img[y*w+x] < threshold.high; x++ ) {}
      for( ; x < w; ) {
       for( ; x < w && img[y*w+x] > threshold.low; x++ ) {}
       if ( x >= w ) break;
       let x0 = x++;
       for( ; x < w && img[y*w+x] < threshold.high; x++ ) {}
       if ( x >= w ) break;
       let x1 = x++;
       row.push(x0,x1);
       bwlist.push(x1-x0);
      }
     }
    }

    // find major bar width
    let barWidth;
    {
     bwlist = bwlist.sort(function(a,b){return b-a;});
     let total = 0;
     for( let i = 0; i < bwlist.length; i++ ) total += bwlist[i];
     let th = 1/2*total;
     let len = 0;
     for( let i = 0; i < bwlist.length; i++ ) {
      len += bwlist[i];
      if ( len > th ) { barWidth = bwlist[i]; break; }
     }
    }


    // remove narrow bar
    let barpos = [];
    {
     let th = (1/2)*barWidth;
     for( let i = 0; i < edges.length; i++ ) {
      let erow = edges[i];
      let brow = barpos[i] = [];
      for( let j = 0; j < erow.length; j+=2 ) {
       let x0 = erow[j], x1 = erow[j+1];
       if ( x1-x0 < th ) { continue; }
 //console.log(x1-x0);
       brow.push((x1+x0)/2);
      }
     }
    }

    // correct
    {
     let ystep = (h - 2*rBlurV)/(N_ROW-1);
     let fovList = [];
     let edgeList = [];
     for( let i = 0; i < barpos.length; i++ ) {
      let y = rBlurV + Math.round(i*ystep);
      let edge2 = pitchErrorCorrect(barpos[i]);
      // この判定はedgeDetect内で
      if ( edge2 && edge2.length >= 2 ) {
       let fov = pitch*(edge2.length-1)*
         imageWidth/(edge2[edge2.length-1]-edge2[0]);
       fovList.push(fov);
       edgeList.push({ y: y, list: edge2 });
      }
     }

     let fov;
     if ( fovList.length >= 5 ) {
      fovList = fovList.sort(function(a,b){return a-b;});
      let i = Math.floor(1/2*fovList.length)-1;
      let n = 3;
      let sum = 0;
      for( let j = 0; j < n; j++ ) {
       sum += fovList[i+j];
      }
      fov = sum/n;
     }

     // error
     res = { fov: fov, edgeList: edgeList };
    }

    res.blur = img;
   }
   catch(e){
    console.log(e);
   }
   return res;
  }


  // Threshold
  function levelDetect(img,w,h){
   let histgram = new Array(256);
   for( let i = 0; i < histgram.length; i++ ) { histgram[i] = 0; }
   let n = w*h;
   for( let i = 0; i < n; i++ ) { histgram[Math.floor(img[i])]++; }
   let total = 0;
   for( let i = 0; i < histgram.length; i++ ) { total += histgram[i]; }
   let countLow = total*0.1;
   let countHigh = total*0.9;
   let levelLow, levelHigh;
   let count = 0;
   let i;
   for( i = 0; i < histgram.length; i++ ) {
    if ( count > countLow ) { levelLow = i; break; }
    count += histgram[i];
   }
   if ( levelLow === undefined ) {
    console.log(total,countLow,countHigh,count);
    throw 'levelDetect#1';  // unknown error
   }
   for( ; i < histgram.length; i++ ) {
    if ( count > countHigh ) { levelHigh = i; break; }
    count += histgram[i];
   }
   if ( levelHigh === undefined ) {
    levelHigh = 255;
   }
   let margin = levelHigh - levelLow;
   if ( margin < 32 ) {
    throw 'Contrast Too low';
   }
   let threshold = {
    low : 1/3*margin + levelLow,
    high: 2/3*margin + levelLow
   };
//console.log('level',levelLow,levelHigh,threshold.low,threshold.high);
   return threshold;
  }


  function horizBlur(s,t,w,h,r){
   if ( r > w-1 ) { r = w-h; }
   let scale = 1/(r*2+1);
   let x, y;
   for( y = 0; y < h; y++ ) {
    let v = s[y*w];
    let sum = v*(r+1);
    for( x = 0; x < r; x++ ) { sum += s[y*w+x]; }
    for( x = 0; x <= r; x++ ) {
     sum += s[y*w+x+r]-v; t[y*w+x] = sum*scale;
    }
    for( x = r+1; x < w-r; x++ ) {
     sum += s[y*w+x+r]-s[y*w+x-r-1]; t[y*w+x] = sum*scale;
    }
    v = s[y*w+w-1];
    for( x = w-r; x < w; x++ ){
     sum += v-s[y*w+x-r-1]; t[y*w+x] = sum*scale;
    }
   }
  }


  function vertBlur(s,t,w,h,r){
   if ( r > h-1 ) { r = h-1; }
   let scale = 1/(r*2+1);
   let x, y;
   let n = w*h;
   for( x = 0; x < w; x++ ) {
    let v = s[x];
    let sum = v*(r+1);
    for( y = 0; y < r; y++ ) { sum += s[y*w+x]; }
    for( y = 0; y <= r; y++ ) {
     sum += s[(y+r)*w+x]-v; t[y*w+x] = sum*scale;
    }
    for( y = r+1; y < h-r; y++ ) {
     sum += s[(y+r)*w+x]-s[(y-r-1)*w+x]; t[y*w+x] = sum*scale;
    }
    v = s[(h-1)*w+x];
    for( y = h-r; y < h; y++ ) {
     sum += v-s[(y-r-1)*w+x]; t[y*w+x] = sum*scale;
    }
   }
  }


  // (posList)
  function pitchErrorCorrect(posList){
   let pitchAvr;  // median value
   {
    let p = [];
    for( let i = 0; i < posList.length-1; i++ ) {
     p[i] = posList[i+1]-posList[i];
    }
    p = p.sort(function(a,b){return a-b;});
    pitchAvr = p[Math.floor(p.length/2)];
   }
   let list0 = [];
   let i = 0;
   while( i < posList.length-1 ) {
    //
    let list1 = [];
    let x0 = posList[i];
    let last = i;
    let j = 0;
    list1[j++] = x0;
    let count = 0;
    let errorCount = 0;
    for( i++; i < posList.length; i++ ) {
     let x1 = posList[i];
     let l = x1-x0;
     let m = Math.round((x1-x0)/pitchAvr);
     let pitchError = m == 0? 1: Math.abs(l-m*pitchAvr)/(m*pitchAvr);
     if ( pitchError < PITCH_ERROR_LIMIT ) {
      for( let k = 1; k < m; k++ ) {
       list1[j++] = x0+k*l/m;
      }
      list1[j++] = x1;
      count += m;
      x0 = x1;
      errorCount = 0;
      last = i;
     }
     else {
      errorCount++;
      if ( errorCount > EDGE_ERROR_LIMIT ) { break; }
     }
    }
    if ( list1.length > list0.length ) { list0 = list1; }
    i = last+1;
   }

// 十分な長さがあること!
// list[list.length-1]-list[0] > w/2
   return list0;
  }


  return FpDetect;
 });
})();

