//
// input tool
// 分離してみたが...
// 

(function(){
 'use strict';
 const Ld = sLoader;

 Ld.module('gui-select',function(){
  
  const U = Ld.use('utility');
  const Gui = Ld.use('gui-object');

  const C = Gui.Select = Gui.Object.derive();

  C.boxEl = undefined;

  C.default = '';

/*
  C.cellHeight = 90;
  C.fontSize = '56px';
  C.lineHeight = '74px';
*/
  C.cellHeight = 32;
  C.fontSize = '24px';
  C.lineHeight = '24px';

  C.cellPadH = 8;  // 単位... 
  C.cellPadV = 4;   //
  C.autoWidth = true;
  C.style = {};
  C.whiteSpace = 'nowrap';

  C.open = function(){
   if ( !this.boxEl ) { return; }
   this.close(); //...

   let frameEl = this.frameEl = document.createElement('div');
   frameEl.className = 'scrollbox';
   U.setStyle(frameEl.style,{
    width:'100%', height:'100%',
    boxSizing:'border-box',
    overflow:'scroll',
    WebkitOverflowScrolling:'touch',
    fontSize: this.fontSize,
    lineHeight: this.lineHeight,
    cursor:'default',
   });
   U.setStyle(frameEl.style,this.style);
   this.boxEl.appendChild(frameEl);

   let obj = this;
   this.addHandler(frameEl,'scroll',function(ev){ obj._onscroll(ev); });
   this.addHandler(frameEl,'click',function(ev){ obj._onclick(ev); });
   this.addHandler(frameEl,'mousedown',function(ev){
    ev.stopPropagation();
   });
   this.addHandler(frameEl,'touchstart',function(ev){
    ev.stopPropagation();
   });

   this.status = [];
   this.index = [];
   let list = this.list;
   if ( frameEl && list ) {
    let html = '';
    let height = this.cellHeight;
    let padh = this.cellPadH;
    let padv = this.cellPadV;
    for( let i = 0; i < list.length; i++ ) {
     let cell = document.createElement('div');
     cell.className = 'select-cell';
     U.setStyle(cell.style,{
      position:'relative',
      height:height+'px',
      padding:`${padv}px ${padh}px`,
      overflow:'hidden',
      whiteSpace:this.whiteSpace,
      outlineOffset:'-8px',
      boxSizing:'border-box',
     });
     frameEl.appendChild(cell);
    }
    this.index = frameEl.getElementsByClassName('select-cell');
    if ( this.autoWidth ) {
     let list = this.list;
     for( let i = 0; i < list.length; i++ ) {
      let item = list[i];
      this.showItem(i,this.index[i]);
      this.status[i] = true;
     }
    }
   }
   this.setValue(this.value);
  };

  C.close = function(){
   this.frameEl = undefined;
   this.index = undefined;
    //  
   C._super.close.call(this);
  };

  C._onscroll = function(ev){
   let el = this.frameEl;
   let list = this.list;
   let i0 = Math.floor(el.scrollTop/this.cellHeight);
   let i1 = Math.ceil((el.scrollTop+el.offsetHeight)/this.cellHeight);
   for( let i = i0; i <= i1 && i < list.length; i++ ) {
    if ( !this.status[i] ) {
     this.status[i] = true;
     this.showItem(i,this.index[i]);
    }
   }
  };

  C._onclick = function(ev){
   let el = this.frameEl;
   let pt = U.convertFromScreenCoordinate(this.frameEl,
     {x:ev.clientX, y:ev.clientY});
   let i = Math.floor((el.scrollTop+pt.y)/this.cellHeight);
   let item = this.list[i];
   let value = typeof(item) == 'object'?
    (item.value !== undefined? item.value: item[0]): item;
// 変更されていたら
   this._value = value;
   if ( this.oninput ) {
    this.oninput();
   }
  };

  C.showItem = function(i,cell){
  // list[i]
   let list = this.list;
   if ( list ) {
    let item = list[i];
    let text = typeof(item) == 'object'
     ? (item.htmlText !== undefined? item.htmlText:
       (item.text != undefined? U.htmlEscape(item.text):
       (item.value != undefined? U.htmlEscape(item.value):
       U.htmlEscape(item[1]))))
     : U.htmlEscape(item);
    cell.innerHTML = text;
    if( this._value == (typeof(item) == 'object'?
      (item.value !== undefined? item.value: item[0]): item) ) {
     U.setStyle(cell.style,{
      filter: 'grayscale(0%)',
//      opacity:0.8,
      outline: 'solid 8px rgba(33,150,243,0.8)'
     });
    }
    else {
     U.setStyle(cell.style,{
      filter: 'grayscale(80%)',
//      opacity:0.8,
//      outline: 'solid 8px rgba(33,150,243,0.8)'
     });
    }
   }
  };

  C.setValue = function(value){
   this._value = value;
   if ( this.frameEl ) {
    let el = this.frameEl;
    let list = this.list;
    let pos = 0;
    for( let i = 0; i < list.length; i++ ) {
     let item = list[i];
     if( value == (typeof(item) == 'object'?
       (item.value !== undefined? item.value: item[0]): item) ) {
      pos = i;
      break;
     }
    }
    el.scrollTop = pos*this.cellHeight;
    let row = Math.ceil(el.offsetHeight/this.cellHeight);
    let i1 = pos + row-1;
    if ( i1 >= list.length ) { i1 = list.length-1; }
    let i0 = i1 - (row-1);
    if ( i0 < 0 ) { i0 = 0; }
    for( let i = i0; i <= i1; i++ ) {
     this.showItem(i,this.index[i]);
    }
   }
  };

  return Gui;
 });

})();
