/*
   gui-slider
   Gui.Slider

  gui-slider


  focus()
   使えないけど入れておくか。

  log ...
*/
(function(){
 'use strict';
 const Ld = sLoader;

 Ld.module('gui-slider',function(){

  const U       = Ld.use('utility');
  const Gui     = Ld.use('gui-object');

  // Gui.Slider
  const C = Gui.Slider = Gui.Object.derive();

// BaseElement
  C.boxEl       = undefined;
  C.paddingH    = 20;   // percentage of height
  C.thumbSize   = 80;   // percentage of height
  C.borderRadius = 50;
  C.min         = 0;
  C.max         = 1;
  C.frameStyle  = {
   border:'solid 4px black',
//   backgroundColor:'rgba(255,255,255,0.4)',
  };
  C.thumbStyle = {
//   border:'solid 4px black',
   borderStyle:'solid',
   borderWidth:'4px',
   borderRadius:'50%',
//   backgroundColor:'rgba(255,255,255,0.4)',
  };
  // C.thumbText = undefined;

  C.open = function(){
   if ( this.boxEl ) {
    this.close();  // 内容を書き換えるか...
    let frameEl = this.frameEl = document.createElement('div');
    U.setStyle(frameEl.style,{
     position:'absolute',
     top:0, bottom:0, width:'100%', height:'100%',
     boxSizing:'border-box',
     overflow:'hidden',
    });
    if ( this.frameStyle ) {
     U.setStyle(frameEl.style,this.frameStyle);
    }
    let thumbEl = this.thumbEl = document.createElement('div');
    thumbEl.className = 'menu-color';
    U.setStyle(thumbEl.style,{
     position:'absolute', boxSizing:'border-box',
    });
    if ( this.thumbStyle ) {
     U.setStyle(thumbEl.style,this.thumbStyle);
    }
    if ( this.thumbText ) {
     thumbEl.innerHTML = this.thumbText;
    }
    frameEl.appendChild(thumbEl);
    let obj = this;
    this.addHandler(frameEl ,'mousedown' ,function(ev){obj._mousedown(ev);});
    this.addHandler(frameEl ,'touchstart',function(ev){obj._mousedown(ev);});
    this.addHandler(document,'mousemove' ,function(ev){obj._mousemove(ev);});
    this.addHandler(frameEl ,'touchmove' ,function(ev){obj._mousemove(ev);});
    this.addHandler(document,'mouseup'   ,function(ev){obj._mouseup(ev);});
    this.addHandler(frameEl ,'touchend'  ,function(ev){obj._mouseup(ev);});
    this.boxEl.appendChild(frameEl);
// boxElがdocumentにつながっていないと大きさがわからないぞ。
// イベントがあるのか?
    this.onresize();
   }
  };

  C.close = function(){
   if ( this.frameEl ) {
    this.eraseHandler();
    this.boxEl.removeChild(this.frameEl);
    this.frameEl = undefined;
    this.thumbEl = undefined;
   }
  };

  C._getGeometry = function(){
   let geom;
   if ( this.frameEl ) {
    geom = {};
    geom.width = this.frameEl.offsetWidth;
    geom.height = this.frameEl.offsetHeight;
    geom.padding = (this.paddingH+this.thumbSize/2)/100*geom.height;
    geom.range = geom.width-2*geom.padding;
    geom.borderWidth = (this.frameEl.offsetWidth-this.frameEl.clientWidth)/2;
   }
   return geom;
  };

// event拾えなかったよな?
  C.onresize = function(){
   let geom = this._getGeometry();
   if ( geom ) {
    // borderRadius 
    if ( this.borderRadius ) {
     U.setStyle(this.frameEl.style,{
      borderRadius:(this.borderRadius/100*geom.height)+'px'
     });
    }

    let width = this.thumbSize/100*geom.height;
    U.setStyle(this.thumbEl.style,{
     width:width+'px', height:width+'px',
     border:`solid ${this.borderWidth}px black`,
    });
    this._setThumbPos();
   }
  };

  C._setThumbPos = function(){
   let geom = this._getGeometry();
   if ( geom ) {
    let style = {};
    // max != min
    let x = (this.value-this.min)/(this.max-this.min)*geom.range+geom.padding
     - this.thumbSize/200*geom.height
     - geom.borderWidth;
    let y = geom.height*(0.5-this.thumbSize/200) - geom.borderWidth;
    style.left = x+'px';
    style.top = y+'px';
    U.setStyle(this.thumbEl.style,style);
   }
  };

  C._mousedown = function(ev){
   ev.preventDefault();
   ev.stopPropagation();
// clickを判定するなら少し待たないといけない
   if ( !this._status ) {
    this._status = 1;
    this._startValue = this.value;
    this._drag(ev);
   }
  };

  C._mousemove = function(ev){
   if ( this._status ) {
    ev.preventDefault();
    ev.stopPropagation();
    this._drag(ev);
   }
  };

  //
  C._mouseup = function(ev){
   if ( this._status ) {
    ev.preventDefault();
    ev.stopPropagation();
    if ( this.value != this._startValue && this.onchange ) {
     this.onchange();
    }
    this._status = undefined;
   }
  };

//  C.onChange = function(value){};

  C._drag = function(ev){
   let geom = this._getGeometry();
   if ( geom ) {
    if ( ev.touches ) { ev = ev.touches[0]; }
    let pt = U.convertFromScreenCoordinate(this.frameEl,
     {x:ev.clientX,y:ev.clientY});
    let pos = (pt.x-geom.padding)/geom.range;
    let value;
    if ( geom.range == 0 ) {
     value = this.min;
    } else {
     value = pos*(this.max-this.min) + this.min;
    }
    let min = Math.min(this.min,this.max);
    if ( value < min ) { value = min; }
    let max = Math.max(this.min,this.max);
    if ( value > max ) { value = max; }
    if ( value != this._value ) {
     this._value = value;
     this._setThumbPos();
     if ( this.oninput ) { this.oninput(); }
    }
   }
  };

  C.getValue = function(){
   if ( this._value === undefined ) {
    this._value = this.default;
   }
   if ( this._value === undefined ) {
    this._value = (this.min+this.max)/2;
   }
   return this._value;
  };

  C.setValue = function(value){
   this._value = value;
   this._setThumbPos();
  };

  return Gui;
 });

})();
