(function(){
 'use strict';

// lp-fov

 const Ld = sLoader;
 sLoader.module('lp-fov',function(){

  let Lp  = Ld.use('layerParts');
  let M   = Ld.ref('main');
  let Mn  = Ld.use('menu');
  let Measure = Ld.use('measure');
  let Cp  = Ld.use('cropParam');
  let Mp  = Ld.use('mainParam');
  let U   = Ld.use('utility');
  let Fov = Ld.use('fov');
  let Cons= Ld.use('console');
  let Mb  = Ld.use('messageBox');

  let LpF = Lp.derive();

  LpF.sig = 'Measure';


  LpF.defineMenu = function(){
   LpF._super.defineMenu.call(this);
   let obj = this;
   this.menu = {
    sw: Mn.visibilitySwitch({priority:95}),
    method:
        Mn.CSelect.create({priority:90,
         buttonText:'Method',
         list:[
          [ 'auto'    , 'auto'      ],
          [ 'longside', 'manual(long side)' ],
//          [ 'manual'  , 'manual(ref. points)'    ]
         ]
        }),
    profiles:
        Mn.CSelect.create({priority:85,
         cellHeight: 120,
         buttonText:'Profile',
         fontSize:'28px',
         lineHeight:'1.2',
         whiteSpace:'normal',
        }),
    dimension:
        Mn.CText.create({priority:80,
         buttonText:'Dimension',
//
         historyKey:'referenceLength',
// 表示されねぇ
         placeholder: `Dimension (e.g. '10mm')`,
        }),
/*
    points:
        Mn.button({priority:70,
         text:'Reference<br>Points',
         onclick:function(){ obj.measure(); }
        }),
*/
/*
保留
    manage:
        Mn.CSubmenu.create({priority:30,
         text: 'Manage',
         submenuId: 'FOVManage',
       }),
*/
/**/
   };
   this.addMenu(this.menu);

   Mn.CMenuDef.create({
    id:'FOVManage',
    items: {
     import:
         Mn.button({priority:90,
          text: 'Import',
          onclick: function(){ obj.importProfile(); }
         }),
     reset:
         Mn.button({priority:90,
          text: 'Reset',
          onclick: function(){ obj.resetProfile(); }
         }),
     clear:
         Mn.button({priority:90,
          text: 'Clear',
          onclick: function(){ obj.clearProfile(); }
         }),
    }
   });
  };



  LpF.initialize = function(){
   LpF._super.initialize.call(this);
   let obj = this;
   this.measureTool = Measure.create({
    menuId:this.id+'_measure',
    editMenu:{
     '0,0': {
        icon: 'S',
        onclick:function(){ obj.setPoint(); }
       },
     '0,1': {
        icon: 'R',
        onclick:function(){ obj.erase(); }
       },
    }
   });
// attr
   this.values = {};
  };


  LpF.getHFOV = function(){
   let V = this.values;
   let hfov;
   if ( V.sw ) {
    switch(V.method){
    case 'auto'    : hfov = Mp.hfov; break;
    case 'longside': hfov = U.parseDimension(V.dimension).mm; break;
    case 'manual'  : 
      if ( V.pt ) {
       let len = U.dist(V.pt[1].x-V.pt[0].x,V.pt[1].y-V.pt[0].y);
       let d = U.parseDimension(V.dimension).mm;
       if ( d && len > 0 ) {
        hfov = Mp.imageWidth/Mp.imageDiagonal/len*d;
       }
      }
      break;
    }
   }
   return hfov;
  };


  LpF.onOpenImage = function(){
   let V = this.values;
   this.menuDefs.profiles.setProperties({ list: [] });
   let settings = {};
   settings.sw = false;
   settings.profiles = '';
   this.restoreSessionStatus(settings)
   let key = Fov.getKey(Mp.exif);
   if ( key && Mp.fovSettings ) {
    let settings = Mp.fovSettings[key];
    this.restoreSessionStatus(settings)
   }
   let profileText = this.menuDefs.profiles.value;
   if ( V.sw && V.method==='auto' && profileText ) {
    let profile;
    try { profile = JSON.parse(profileText); }
    catch(e) {console.error(e);}
    if ( profile ) {
     let fov = Fov.compute(profile,Mp.exif);
     Mp.hfov = fov.width;
    }
    // saveSesssionStatus
   }
  };


  LpF.onChange = function(data){
//console.log('onChange',data);
   LpF._super.onChange.call(this,data);
   let key = Fov.getKey(Mp.exif);
   if ( key ) {
    if ( Mp.fovSettings === undefined ) {
     Mp.fovSettings = {};
    }
    let settings = Object.assign({},this.getSessionStatus());
    settings.sw = false;
    Mp.fovSettings[key] = settings;
   }
   if ( this.values.sw && this.values.method==='auto'
     && this.values.profiles ) {
    let profile;
    try{ profile = JSON.parse(this.values.profiles); }
    catch(e) { console.error(e); }
    if ( profile ) {
     let fov = Fov.compute(profile,Mp.exif);
     if ( fov ) Mp.hfov = fov.width;
    }
// saveSesssionStatus
   }
   M.redraw();
  };


// check!
  LpF.restoreSessionStatus = function(data){
   // Mp.exif
   let proflist = Fov.getList(Mp.exif);
   let list = [];
   for( let i = 0; i < proflist.length; i++ ) {
    list[i] = {
     text : proflist[i].description,
     value: JSON.stringify(proflist[i])
    };
   }
   this.menuDefs.profiles.setProperties({
    list: list
   });
   if ( !data ) {
    data = {};
    data.method = 'auto';
    if ( list.length > 0 ) {
     data.profiles = list[0].value;
    }
   }
   LpF._super.restoreSessionStatus.call(this,data);
   this.values.pt = data.pt;
  };


  LpF.measure = function(){
   Mn.open(this.measureTool.menuId);
  };


  LpF.setPoint = function(){
//console.log(this.values);
   let pt = this.measureTool.getPos();
   let V = this.values;
   if ( !V.pt ) {
    V.pt = [ pt, pt ];
    V.editMode = true;
    V.which = 1;
   }
   else if ( V.editMode ) {
    V.pt[V.which] = pt;
    V.editMode = false;
   }
   else {
    // modify ??
   }
   this.dirty = true;
   M.disp();
  };

  //
  LpF.modify = function(){
  };


  LpF.erase = function(){
   this.values.pt = undefined;
   this.values.editMode = false;
   this.dirty = true;
   M.disp();
  };


  LpF.onresize = function(){
   if ( this.values.editMode ) {
    let pt = this.measureTool.getPos();
    this.values.pt[this.values.which] = pt;
   }
   this.dirty = true;
   M.disp();
  };


// imageCoordTo
// main
  function imageCoordTo(scale,pt) {
   let s = Cp.transform.zoom;
   let sx = Cp.mirror? -s: s;
   let sy = s;
   let x0 = sx*pt.x;
   let y0 = sy*pt.y;
   let t = 2*Math.PI*Cp.transform.rotation;
   let x1 = x0*Math.cos(t) - y0*Math.sin(t);
   let y1 = x0*Math.sin(t) + y0*Math.cos(t);
   let x2 = scale*(x1 + Cp.transform.x);
   let y2 = scale*(y1 + Cp.transform.y);
   return{ x: x2, y: y2 };
  }


// preview/final, param
  LpF.makeSvgText = function(final,p){
   let V = this.values;
   let svg = '';
   if ( !V.pt || V.method != 'manual' ) { return svg; }
   let scale = p.cRect.diagonal;
   let x = -scale*(Cp.width*0.2);
   let y = -scale*(Cp.height*0.2);
   let bw = scale*(Cp.width*1.4);
   let bh = scale*(Cp.height*1.4);

   svg = `<svg viewBox="${-bw/2} ${-bh/2} ${bw} ${bh}"
     x="${x}" y="${y}" width="${bw}" height="${bh}"
     style="position:absolute; left:${x}px; top:${y}px;"
     opacity="${V.opacity/100}"
     xmlns="http://www.w3.org/2000/svg"
     xmlns:xlink="http://www.w3.org/1999/xlink"
    >`;

   let bgcolor = 'white';
   let color = 'black';
   let lw = 1.5;
//   let lw = 0.8/1000*scale;
   let lwb = 5;
//   let lwb = 3/1000*scale;

   let pt0 = imageCoordTo(scale,V.pt[0]);
   let pt1 = imageCoordTo(scale,V.pt[1]);
   let d = `M ${pt0.x} ${pt0.y} L ${pt1.x} ${pt1.y}`;
   svg += `<path d="${d}"
    stroke-width="${lwb}" stroke-linecap="round"
    stroke-linejoin="round" stroke="${bgcolor}"
    opacity="0.4"
    fill="none"
   />`;
   svg += `<path d="${d}"
    stroke-width="${lw}" stroke-linecap="butt"
    stroke-linejoin="round" stroke="${color}"
    fill="none"
    />`;

   svg += '</svg>';
   return svg;
  };


  LpF.resetProfile = function(){
   let obj = this;
   let mb = Mb.messageBox({
    text:`<h2>FOV profiles will be reset to the builtin state.</h2>
     <p><button class="mbReset">RESET</button></p>`,
    buttons:{
     mbReset: ev=>{
      mb.close();
      Fov.reset();
      M.saveProfiles();
      obj.restoreSessionStatus(obj.getSessionStatus());
     }
    }
   });
  };

  
  LpF.clearProfile = function(){
   let obj = this;
   let mb = Mb.messageBox({
    text:`<h2>FOV profiles will be cleared completely.</h2>
     <p><button class="mbClear">CLEAR</button></p>`,
    buttons:{
     mbClear: ev=>{
      mb.close();
      Fov.clear();
      M.saveProfiles();
      obj.restoreSessionStatus(obj.getSessionStatus());
     }
    }
   });
  };


  LpF.importProfile = function(){
   (async()=>{
    let files = await U.openFileP({ accept:'application/json',
     multiple:true, name:'files[]'});
    M.startLoadingEffect();
    let profileList = [];
    const m = 8;
    for( let i = 0; i < files.length; i += m){
     if ( files[i].type !== 'application/json' ) continue;
     let p = [];
     let n = Math.min(files.length-i,m);
     for(let j = 0; j < n; j++ ) {
      p[j] = U.readAsTextP(files[i+j]);
     }
     let results = await Promise.all(p);
     results.forEach(text=>{
      profileList.push(JSON.parse(text));
     });
    }
    for(let i = 0; i < profileList.length; i++ ) {
     Fov.addProfile(profileList[i]);
    }
    this.restoreSessionStatus(this.getSessionStatus());
    M.saveProfiles();
    // save!
   })()
   .then((profileList)=>{
    M.stopLoadingEffect();
   })
   .catch((e)=>{
    M.stopLoadingEffect();
    M.error(e);
   });
  };

  
  return LpF;

 });

})();
