(function(){
 'use strict';

 const Ld = sLoader;
 sLoader.module('measure',function(){

  let View = Ld.use('view');
  let Measure = View.derive();
  let M  = Ld.ref('main');
  let U  = Ld.use('utility');
  let Mn = Ld.use('menu');
  let Mp = Ld.use('mainParam');
  let Cp = Ld.use('cropParam');

  Measure.open = function(){
   Measure._super.open.call(this);
console.log('measure');
   let bw = 100;
   let bh = 100;
   let d1 = 10;
   let d2 = 0.8;
   let lw = 0.2;
   let lwb = 0.6;
   let markEl = this.markEl = document.createElement('div');
   U.setStyle(markEl.style,{
    position:"absolute",
    top:0, left:0, right:0, bottom:0,
    zIndex:10,
   });
   markEl.innerHTML = `<svg 
     viewBox="${-bw/2} ${-bh/2} ${bw} ${bh}"
     width="100%" height="100%"
     opacity="0.8"
     xmlns="http://www.w3.org/2000/svg" >
    <g stroke="white" opacity="0.4" stroke-linecap="round">
     <path d="M ${-d1} 0 L ${-d2} 0" stroke-width="${lwb}"  />
     <path d="M ${d1} 0 L ${d2} 0" stroke-width="${lwb}"  />
     <path d="M 0 ${d1} L 0 ${d2}" stroke-width="${lwb}"  />
     <path d="M 0 ${-d1} L 0 ${-d2}" stroke-width="${lwb}"  />
    </g>
    <g stroke="black" stroke-linecap="round">
     <path d="M ${-d1} 0 L ${-d2} 0" stroke-width="${lw}" />
     <path d="M ${d1} 0 L ${d2} 0" stroke-width="${lw}" />
     <path d="M 0 ${d1} L 0 ${d2}" stroke-width="${lw}" />
     <path d="M 0 ${-d1} L 0 ${-d2}" stroke-width="${lw}" />
    </g>
    </svg>`;
   M.screenEl.appendChild(markEl);


// sideButton
   let obj = this;
   this.toolButton = Mn.CPopupButton.create({
    id:'tool',
    parent:Mn.guiScreen,
// yは2
// x無し
    x: 40, y: 800,
//    row: 2,
    icon: 'R',

    submenu:this.editMenu,
/*
    {
     '0,0': {
        icon: 'S',
        onclick:function(){ if ( obj.set ) { obj.set(); } }
       },
     '0,1': {
        icon: 'E',
        onclick:function(){ if ( obj.endPath ) { obj.endPath(); } }
       },
     '1,1': {
        icon: 'C',
        onclick:function(){ if ( obj.closePath ) { obj.closePath(); } }
       },
    }
*/
   });

//   this.toolButton.open();
// navi, view, tool
   Mn.dispSideButtons(['back','viewMenu','tool']);

  };


  Measure.close = function(){
   if ( this.markEl ) {
    M.screenEl.removeChild(this.markEl);
    this.markEl = undefined;
   }
   if ( this.toolButton ) {
    this.toolButton.close();
    this.toolButton = undefined;
   }
   Measure._super.close.call(this);
  };


  Measure.getPos = function(){
   // invert
   let scale = 1/Cp.transform.zoom;
   let scaleX = Cp.mirror? -scale: scale;
   let scaleY = scale;
   let x0 = -Mp.view.x/Mp.view.scale - Cp.transform.x;
   let y0 = -Mp.view.y/Mp.view.scale - Cp.transform.y;
   let t = -2*Math.PI*Cp.transform.rotation;
   let x1 = scaleX*(x0*Math.cos(t) - y0*Math.sin(t));
   let y1 = scaleY*(x0*Math.sin(t) + y0*Math.cos(t));
   return { x:x1, y:y1 };
  };


  Measure.setStartPoint = function(){
   let pos = this.getPos();
   console.log('start',pos);
  };


  Measure.setEndPoint = function(){
   let pos = this.getPos();
   console.log('end',pos);
  };


  return Measure;

 });
})();
