/*

  Mn.MenuDef.create(

  menu = Mn.create({
   owner: 'layer1',
   title: 'title',
   items: items,
   callback: function(){}
  });

  menu.set(key,{propaty:value,...});
  ...
   
  callback({
   key:value,
   ...
  });


  Mn.base


*/
(function(){
 'use strict';
 const Ld = sLoader;
 Ld.module('menu',function(){

  const Mn = {};
  this.body = Mn;

  Mn.back        = back;
  Mn.onresize    = onresize;
  Mn.open        = open;

  // Mn.CSwitch 
  // ...

  const M        = Ld.ref('main');
  const U        = Ld.use('utility');
  const Icon     = Ld.use('icon');
  const Opt      = Ld.use('option');

// まとめて gui-base
  const Gui      = Ld.use('gui-object');
  Ld.use('gui-slider');
  Ld.use('gui-dial');
  Ld.use('gui-select');



  const N_ITEMS_PER_MENU = 6;
  const MAX_MENU_DEPTH = 6;

  const MBTN_WIDTH = 240;
  const MBTN_HEIGHT = 120; // ->120
  const MBTN_MGNH = 20;
  const MBTN_MGNV = 20;
  const MBTN_BDWD = 4;
 //
  const MBTN_PADH = 32;
  const MBTN_PADV = 12;
  const ICON_SIZE = 76;
  const MENU_HEIGHT      = (MBTN_HEIGHT+MBTN_MGNV)*N_ITEMS_PER_MENU+MBTN_MGNV;
  const MENU_MAX_WIDTH   = MENU_HEIGHT*3/4;
  const MENU_FRAME_PADDING = 10; // %


  let guiScreen;
  let modalScreen;
  let menuMask;
  let menuFrameOuter;
  let menuFrame;
  let partsIndex = {};
  let layerStack = [];
  let layerDepth = -1;
  let menuWidth = [];
  let menuScale = 1;
  let grabbed = false;
  let sideButtons = {};

/*
 SlideMenu
*/
  let menuStatus = {
   active: true,
   visible: true,
   level: 1,
  };

  let leftBar;
  let backButton;
  let showMenuButton;
  let hideButton;
   // menuHide

  let textInputMode = 0;

  Mn.menuMaxWidth = function(){ return MENU_MAX_WIDTH; }

  Mn.start = function(){

   let mainScreen = document.getElementById('mainScreen');

   guiScreen = Mn.guiScreen = document.getElementById('guiScreen');


   let screenObj = Gui.Object.derive();

   screenObj.screenToInternalCoordinate = function(pos){
//    return U.convertFromScreenCoordinate(menuFrame,pos);
    return U.convertFromScreenCoordinate(guiScreen,pos);
   };



//        onmouseleave:function(){ Mn.disp2(layerDepth,menuStatus.level); },

   screenObj.onclick = function(ti){
    let y = ti.pos[0].y;

    Mn.disp2(layerDepth,layerDepth+1);

    

   };
   screenObj.baseElement = guiScreen;
   screenObj.atatch();


   modalScreen = this._modalScreen = document.createElement('div');
   modalScreen.className = 'menu-color';
   U.setStyle(modalScreen.style,{
    display:'none',
    position:'absolute',
    top:0, bottom:0, left:0, right:0,
    backgroundColor:'rgba(0,0,0,0.4)',
    zIndex:9,
   });
   // いろいろ
   modalScreen.addEventListener('mousedown',function(ev){
    ev.stopPropagation();
   });
   modalScreen.addEventListener('touchstart',function(ev){
    ev.stopPropagation();
   });
   guiScreen.appendChild(modalScreen);


   {
    menuMask = document.createElement('div');
    U.setStyle(menuMask.style,{
     position:'absolute',
     left:'160px', right:0,
     top:0,
     height:MENU_HEIGHT+'px',
     zIndex:4,
 //    border:'solid 1px blue',
     overflow:'hidden',
     transformOrigin:'right top',
    });
    guiScreen.appendChild(menuMask);
   }

   menuFrameOuter = document.createElement('div');
   menuFrameOuter.className = 'menu-frame';
   U.setStyle(menuFrameOuter.style,{
    position:'absolute',
    left:'100%',
    transitionProperty:'transform',
   });
   menuMask.appendChild(menuFrameOuter);
   menuFrame = document.createElement('div');
   U.setStyle(menuFrame.style,{
    position:'absolute',
    width: MENU_MAX_WIDTH+'px', height: MENU_HEIGHT+'px',
    zIndex:4,
   });
   menuFrameOuter.appendChild(menuFrame);


// naviMenu
//   sideButtons.back =
   Mn.CPopupButton.create({
    id:'back',
    parent:guiScreen,
    x: 40, y: 80, icon:Icon.back1("100%"),
    getSubmenu:function(){
     let submenu = {
      '0,1': {
        icon:Icon.menu1('100%'),
        onclick:function(){ menuStatus.level = 1; Mn.disp(); },
        onmouseenter:function(){ Mn.disp2(layerDepth,1); },
        onmouseleave:function(){ Mn.disp2(layerDepth,menuStatus.level); },
       },
      '1,1': {
        icon:Icon.menu2('100%'),
        onclick:function(){ menuStatus.level = 2; Mn.disp(); },
        onmouseenter:function(){ Mn.disp2(layerDepth,2); },
        onmouseleave:function(){ Mn.disp2(layerDepth,menuStatus.level); },
       },
      '2,1': {
        icon:Icon.menu3('100%'),
        onclick:function(){ menuStatus.level = 3; Mn.disp(); },
        onmouseenter:function(){ Mn.disp2(layerDepth,3); },
        onmouseleave:function(){ Mn.disp2(layerDepth,menuStatus.level); },
       },
     };
     for( let depth = layerDepth-1; depth >= 0; depth-- ) {
      let iy = 0;
      let ix = layerDepth-depth-1;
      let key = `${ix},${iy}`;
      let icon;
      if ( depth == 0 ) {
       icon = Icon.home("100%");
      } else {
       switch(ix){
       case 0: icon = Icon.back1('100%'); break;
       case 1: icon = Icon.back2('100%'); break;
       case 2: icon = Icon.back3('100%'); break;
       default: icon = '・'; break;
       }
      }
      submenu[key] = {
       icon: icon,
       onclick:function(){Mn.back(depth);},
       onmouseenter:function(){ Mn.disp2(depth,layerDepth+1); },
       onmouseleave:function(){ Mn.disp2(layerDepth,menuStatus.level); }
      };
     }
     return submenu;
    },
   });

//   sideButtons.back.open();


// viewMenu
//   sideButtons.viewMenu =
   
   let submenu = {
    '0,0': {
       icon: Icon.zoomin('100%'),
       onclick:function(){M.zoom();}
      },
    '0,1': {
       icon: Icon.fitMinimum('100%'),
       onclick:function(){M.viewMin();}
      },
    '1,1': {
       icon: Icon.fitToWidth('100%'),
       onclick:function(){M.viewFit();}
      },
    '0,-1': {
       icon: Icon.mask2('100%',true),
       onclick:function(){ M.cropTranslucent(); }
      },
    '1,-1': {
       icon: Icon.mask2('100%',false),
       onclick:function(){ M.cropOpaque(); }
      },
   };

   if ( M.availableFullScreen() ) {
    submenu['1,0'] = {
     icon: Icon.fullscreen('100%'),
     onclick:function(){M.toggleFullScreen();}
    }
   }

   Mn.CPopupButton.create({
    id:'viewMenu',
    parent:guiScreen,
    x: 40, y: 440,
    icon: Icon.zoomin('100%'),
    submenu: submenu
   });
//   sideButtons.viewMenu.open();


   Mn.changeFullScreenIcon = function(sw){
    let icon = sw? Icon.fullscreenExit('100%'): Icon.fullscreen('100%');
    // とりえあず
    submenu['1,0'].icon = icon;
    // sideButtons.viewMenu.changeIcon('1,0',icon);
   };
   
   Mn.dispSideButtons();

// 
   document.addEventListener('keydown',function(ev){
//    if ( ev.altKey || ev.ctrlKey ) {
    if ( textInputMode ) {
    } else {
     switch(ev.keyCode){
//     case 0x41: Mn.showAllToggle(); break;       // A
      // ボタンがスペースでクリックになるようだ。
      // フォーカスを別のキーにするか
     case 0x42: Mn.back(); break;                // B
//     case 0x46: Mn.finishModeToggle(); break;    // F
     }
    }
   });

   onresize();
  };

  Mn.register = function(partsId,parts){
   if ( partsIndex[partsId] ) {
    M.log('menu ID already used',partsId);
    throw('#1592');
   }
   partsIndex[partsId] = parts;
  };


  Mn.unregister = function(partsId){
   delete partsIndex[partsId];
  }


  function setMenuWidth(width){
   if ( width !== undefined ) {
    menuWidth[layerDepth] = (layerDepth > 0? menuWidth[layerDepth-1]: MENU_MAX_WIDTH) + width;
   }
  }


  //
 // すでに開かれていないこと。
  function _open(partsId,depth){
   if ( !depth ) { depth = layerDepth+1; }
   let parts = partsIndex[partsId]
   if ( !parts ) {
    M.log(partsId);
    throw('#3592');
   }
   if ( layerDepth+1 >= MAX_MENU_DEPTH ) {
    M.log('e');
    throw('#9856');
   }
   for( let i = depth; i <= layerDepth; i++ ) {
    partsIndex[layerStack[i]].close();
   }
   layerDepth = depth;
   layerStack[layerDepth] = partsId;
   parts.open(layerDepth);
   setMenuPos(true);
  }

  function open(partsId,depth){
   _open(partsId,depth);
Mn.hilight();
   Mn.disp(true);
  }

 //
  function back(depth){
   if ( depth === undefined ) {
    depth = layerDepth-1;
   }
   if ( depth < 0 ) { depth = 0; }
   for( ; layerDepth > 0 && layerDepth > depth; layerDepth-- ) {
    partsIndex[layerStack[layerDepth]].close();
    layerStack[layerDepth] = undefined;
   }
   setMenuWidth();
   setMenuPos(true);
 // 
   partsIndex[layerStack[layerDepth]].onreturn();
 /*
   partsIndex[layerStack[layerDepth]].activate();
 */
   Mn.active();
   Mn.disp(true);

  }


  function closeAll(){
   for( ; layerDepth >= 0; layerDepth-- ) {
    partsIndex[layerStack[layerDepth]].close();
    layerStack[layerDepth] = undefined;
   }
  }


  function _setMenuPos(depth,transition){
   if ( depth >= 0 ) {
    let right = -menuWidth[depth]*menuScale;
    let height = MENU_HEIGHT*menuScale;
    U.setStyle(menuFrameOuter.style,{
     transitionDuration:`${transition? '0.2s': '0s'}`,
     transform:`translateX(${right}px)`,
    });
   }

  }

  function setMenuPos(transition){
   _setMenuPos(layerDepth,transition);
/*
   if ( layerDepth >= 0 ) {
    let right = -menuWidth[layerDepth]*menuScale;
    let height = MENU_HEIGHT*menuScale;
    U.setStyle(menuFrameOuter.style,{
     transitionDuration:`${transition? '0.2s': '0s'}`,
     transform:`translateX(${right}px)`,
    });
   }
*/
  }

  Mn.active = function(){
   menuStatus.active = true;
   Mn.disp();
  };

  Mn.inactive = function(){
   menuStatus.active = false;
   Mn.disp();
  };

  Mn.show = function(){
   menuStatus.visible = true;
   Mn.disp();
  };

  // guiScreen全体を消す
  Mn.hide = function(){
   menuStatus.visible = false;
   Mn.disp();
  };

/*
  Mn.showAllToggle = function(){
   menuStatus.showAll = !menuStatus.showAll;
   Mn.disp();
  };
*/

/*
M.zoom 
  Mn.finishModeToggle = function(){
   menuStatus.visible = !menuStatus.visible;
   Mn.disp();
  };
*/


  Mn.disp2 = function( depth, column ){
   let transition = true;
   U.setStyle(guiScreen.style,{ display:'block' });
   U.setStyle(menuMask.style,{ display:'block' });
//
   if( depth < 0 ) { depth = 0; }
   let startLevel = Math.max(0,depth-column+1);
   let i = 0;
   for( ; i < startLevel; i++ ) {
    partsIndex[layerStack[i]].inactivate(transition);
   }
   for( ; i <= depth; i++ ) {
    partsIndex[layerStack[i]].activate(transition);
   }
   _setMenuPos(depth,true);
  };

  Mn.disp = function(transition){
   if ( !menuStatus.active ) {
    U.setStyle(menuMask.style,{ display:'none' });
   } else if ( !menuStatus.visible ) {
    U.setStyle(guiScreen.style,{ display:'none' });
   } else {
    U.setStyle(guiScreen.style,{ display:'block' });
    U.setStyle(menuMask.style,{ display:'block' });
//
    let startLevel = Math.max(0,layerDepth-menuStatus.level+1);
    let i = 0;
    for( ; i < startLevel; i++ ) {
     partsIndex[layerStack[i]].inactivate(transition);
    }
    for( ; i <= layerDepth; i++ ) {
     partsIndex[layerStack[i]].activate(transition);
    }
   }
  };


  // default
  Mn.dispSideButtons = function(list){
   if ( !list ) {
    list = [ 'back', 'viewMenu' ];
   }
   for( name in sideButtons ) {
    sideButtons[name].hide();
   }
   for( let i = 0; i < list.length; i++ ) {
    sideButtons[list[i]].show();
   }
  };


  {
   let head = document.getElementsByTagName('head')[0];
   let style = document.createElement('style');
   head.appendChild(style);
   style.sheet.insertRule(
    `.menu-color{
     background-color:white; color:black; border-color:black;
     fill:black;
    }`
    , style.sheet.cssRules.length
   );
   style.sheet.insertRule(
    `.menu-color-svg{
     fill:black;
    }`
    , style.sheet.cssRules.length
   );
   let rule = style.sheet.cssRules[0];
   let svgrule = style.sheet.cssRules[1];

   // change
   Mn.changeMenuColor = function(){
    let opacity = Opt.menuContrast/100;
    if ( opacity > 1 ) { opacity = 1; }
    if ( opacity < 0.2 ) { opacity = 0.2; }

// backColor
    let bc = Opt.menuBackColor||'0,0,0';
    let c = bc.split(/,/).map(parseFloat);
    // tekitou
    let mono = 0.299*c[0] + 0.587*c[1] + 0.114*c[2];
    let fc = mono >= 128? '0,0,0': '255,255,255';
    let color = `rgba(${fc},0.8)`;
    let bgcolor = `rgba(${bc},${opacity})`;
    rule.style.setProperty('background-color',bgcolor);
    rule.style.setProperty('color',color);
    rule.style.setProperty('border-color',color);
    svgrule.style.setProperty('fill',color);
   };

   Mn.setBackColor = function(el,color){
 /*
    if ( el.className.match(/abscolor/) ) {
     let invert = Opt.menuColor == "black"? "invert(100%)": "";
     let elements = guiScreen.getElementsByClassName('abscolor');
     for( let i = 0; i < elements.length; i++ ) {
      U.setStyle(elements[i].style,{ filter:invert });
     }
    }
 */

 // 動的に変わらない...
    let bgcol;
    if ( !color ) {
     bgcol = '';
    } else {
     let opacity = Opt.menuContrast/100;
     if ( opacity > 1 ) { opacity = 1; }
     if ( opacity < 0.2 ) { opacity = 0.2; }
     bgcol = `rgba(${color},${opacity})`;
    }
    U.setStyle(el.style,{ backgroundColor: bgcol});
   };
  }
  

  Mn.hilight = function(){
   for( let i = 0; i < layerDepth; i++ ) {
    if ( partsIndex[layerStack[i]].hilight ) {
     partsIndex[layerStack[i]].hilight(layerStack[i+1]);
    }
   }
  };


  Mn.changeOption = function(values){
   if ( values.menuBackColor !== undefined ||
        values.menuContrast !== undefined ) {
    Mn.changeMenuColor();
    Mn.hilight();
   }
  };

  Mn.restoreSessionStatus = function(data){
   closeAll();
   if ( !data ) { data = {}; }
   let stack = data.stack;
   if ( !stack || stack.length == 0 ) {
    stack = ['main'];
   }
   for( let i = 0; i < stack.length; i++ ) {
    _open(stack[i],i);
   }
//
   let status = data.status;
   if ( status ) {
    Object.assign(menuStatus,status);
   }
   Mn.disp();
   Mn.hilight();
  };

  Mn.getSessionStatus = function(){
   // layerDepth
   let data = {
    stack: layerStack.slice(0,layerDepth+1),
    status: menuStatus,
   };
   return data;
  };


  function onresize(){
   if ( layerDepth >= 0 ) {
    let parts = partsIndex[layerStack[layerDepth]];
    if ( parts.onresize ) {
     parts.onresize();
     return;
    }
   }
   let height = MENU_HEIGHT;
//   let width = height*3/4;       // MIN_MENU_ASPECT
   let width = height;

   let wh = window.innerHeight*(1-2*MENU_FRAME_PADDING/100);
   let ww = window.innerWidth*(1-2*MENU_FRAME_PADDING/100);
   menuScale = Math.min(ww/width,wh/height);
   if ( menuScale > 1 ) { menuScale = 1; }

   let y = (window.innerHeight-height*menuScale)/2;
//
   U.setStyle(menuMask.style,{
    left:(160*menuScale)+'px', right:0,
    top:y+'px',
    height:(MENU_HEIGHT*menuScale)+'px',
   });

   U.setStyle(menuFrame.style,{
    transformOrigin:'left top',
 //   transformOrigin:'right top',
    transform:`scale(${menuScale})`
   });
   setMenuPos(false);

 //  backButton.resize(); // menuScale

/*
   U.setStyle(backButton._frame.style,{
    transformOrigin:'left top',
    transform:`scale(${menuScale})`
   });
   U.setStyle(showMenuButton._frame.style,{
    transformOrigin:'left top',
    transform:`scale(${menuScale})`
   });
*/
/*
   U.setStyle(leftBar.style,{
    transformOrigin:'left top',
    transform:`scale(${menuScale})`
   });
*/
   for( let key in sideButtons ) {
    sideButtons[key].resize(menuScale);
   }

  }


  function restore(id,storage,data){
  }

  function onchange(){
  }



  ///////////////////////////////////////////////////////////////


  // Mn.CObject
  {
   const C = Mn.CObject = Gui.Object.derive();


   C.setProperties = function(p){
    Object.assign(this,p);
    this.refresh();
   };

   C.initialize = function(){ this.refresh(); }

   C.refresh = function(){};


   C.onChange = function(value){
    let name = this.name || this._name; //
    if ( this.owner && name ) {
     let e = {};
     e[name] = value;
     this.owner.onChange(e);
    }
   };


/*
   C.addHandler = function(el,type,handler,capture){
 // もうちょい長い名前
 // _handlerList
    if ( !this._handler ) { this._handler = []; }
    this._handler.push( [ el, type, handler, capture ] );
    el.addEventListener(type,handler,capture);
   };
*/


/*
 // unload時に呼ばれない
 // グローバルにもやらないと...
 // Id
   C.eraseHandler = function(){
    if ( this._handler ) {
     let handlers = this._handler;
     for( let i = 0; i < handlers.length; i++ ) {
      let r = handlers[i];
      r[0].removeEventListener(r[1],r[2],r[3]);
     }
     this._handler = undefined;
    }
   };
*/


   C.getValue = function() {
    if ( this._value === undefined ) { this._value = this.default; }
    return this._value;
   };

   C.setValue = function(value) {
    this._value = value;
    this.refresh();
    }

   Object.defineProperty(C,'value',{
    get: function(){ return this.getValue(); },
    set: function(value){ this.setValue(value); },
   });

   C.correctValue = function(value){ return value; }

  }


  {
   // PopupButton     onclick

   let C = Mn.CPopupButton = Mn.CObject.derive();

   const WIDTH = 180;
   C.x = 0;
   C.y = 0;
   C.icon = "?";
   C.style = { };

   // C.sub.left

   C.initialize = function(){
    C._super.initialize.call(this);
//
    sideButtons[this.id] = this;
   };

   C.getSubmenu = function(){
    return this.submenu;
   };

   C.open = function(){
    let frame = this._frame = document.createElement('div');
    U.setStyle(frame.style,{
     position:'absolute', 
     top:this.y+'px', left:this.x+'px', width:WIDTH+'px', height:WIDTH+'px',
     boxSizing:'border-box', padding:(WIDTH*0.3)+'px',
//     borderStyle:'solid', borderWidth:'4px',
     borderRadius:'10%',
     fontSize:(WIDTH*0.3)+'px', textAlign:'center',
     lineHeight:(WIDTH*0.4)+'px',
     zIndex:8,
    });
    U.setStyle(frame.style,this.style);
    let inner = document.createElement('div');
    inner.className = 'menu-color';
    U.setStyle(inner.style,{
     position:'relative', width:'100%', height:'100%',
     borderRadius:'10%',
     boxSizing:'border-box',
    });
    U.setStyle(inner.style,this.style);
    inner.innerHTML = this.icon;
    frame.appendChild(inner);


    this.parent.appendChild(frame);
    let obj = this;
/*
    this.addHandler(frame,'click',function(ev){ obj._onclick(ev); });
    this.addHandler(frame,'touchend',function(ev){ obj._onclick(ev); });
*/
//
    this.baseElement = frame;
    this.atatch();

    this.resize(menuScale);
   };


// 未テスト
   C.close = function(){
    this.parent.removeChild(this._frame);
    delete sideButtons[this.id];
    C._super.close.call(this);
   };

   function openSubmenu(popup){
    this._submenuEl = {};
    let submenu = this._submenu = this.getSubmenu();
    for( let key in submenu){
     let idx = key.split(/,/).map(function(s){ return parseInt(s); });
     let ix = idx[0];
     let iy = idx[1];
//     if ( !popup && ix == 0 && iy == 0 ) { continue; }
     let el = document.createElement('div');
     el.className = 'menu-color';
     U.setStyle(el.style,{
      position:'absolute',
      top:(menuScale*(this.y+iy*WIDTH))+'px',
      left:(menuScale*(this.x+ix*WIDTH))+'px',
      width:WIDTH+'px', height:WIDTH+'px',
      boxSizing:'border-box', padding:'16px 16px',
      borderStyle:'solid', borderWidth:'4px', borderRadius:'10%',
      fontSize:'80px', textAlign:'center',
      lineHeight:'80px',
      transformOrigin:'left top',
      transform:`scale(${menuScale})`,
      zIndex:10,
     });
     U.setStyle(el.style,this.style);
     if ( submenu[key].icon ) {
      el.innerHTML = submenu[key].icon;
     }
     this.parent.appendChild(el);
     this._submenuEl[key] = el;
    }
   }

/*
   C.changeIcon = function(key,icon){
     this._submenuEl[key].innerHTML = icon;
   };
*/

   function closeSubmenu(){
    if ( this._submenuEl ) {
     for( let key in this._submenuEl ) {
      this.parent.removeChild(this._submenuEl[key]);
     }
     this._submenuEl = undefined;
    }
   }

   C.onmousedown = function(ev){
    this.mouseStatus = 'down';
    openSubmenu.call(this);
    let key = '0,0';
    this.lastKey = key;
    if ( this._submenu[key] && this._submenu[key].onmouseenter ) {
     this._submenu[key].onmouseenter();
    }
   };

   C.ontouch1move = function(ti){
    let ix = Math.floor(ti.pos[0].x / WIDTH);
    let iy = Math.floor(ti.pos[0].y / WIDTH);
    let key = ix+','+iy;
    let lastkey = this.lastkey;
    if ( key != lastkey ) {
     this.lastkey = key;
     if ( this._submenu[lastkey] && this._submenu[lastkey].onmouseleave ) {
      this._submenu[lastkey].onmouseleave();
     }
     if ( this._submenu[key] && this._submenu[key].onmouseenter ) {
      this._submenu[key].onmouseenter();
     }
    }
   };

   C.ontouch1end = function(ti){
    closeSubmenu.call(this);
    let ix = Math.floor(ti.pos[0].x / WIDTH);
    let iy = Math.floor(ti.pos[0].y / WIDTH);
    let key = ix+','+iy;
    if ( this._submenu[key] ) {
     this._submenu[key].onclick();
    }
   };


// menu itemとは別にする。
   C.onclick = function(){
    if ( this._submenu ) {
     closeSubmenu.call(this);
     if ( this._submenu['0,0'] ) {
      this._submenu['0,0'].onclick();
     }
    }
   };

/*
   C._onclick = function(ev){
    ev.preventDefault();
    ev.stopPropagation();
    this.onclick();
   };
*/

   C.show = function(){
    if ( !this._frame ) {
     this.open();
    }
    this._frame.style.display = 'block';
   };

   C.hide = function(){
    if ( this._frame ) {
     this._frame.style.display = 'none';
    }
   };

   C.hilight = function(){};

   C.resize = function(scale){
    if ( this._frame ) {
     U.setStyle(this._frame.style,{
      top:(scale*this.y)+'px', left:(scale*this.x)+'px',
      transformOrigin:'left top',
      transform:`scale(${scale})`
     });
    }
   };

  }


  // ButtonParts
  {
   // MomentarySwitch  onpush onpull

   let C = Mn.CMomentarySwitch = Mn.CObject.derive();

   const WIDTH = 120;
   const HEIGHT = 120;

   C.x = 0;
   C.y = 0;
   C.icon = "?";

   C.open = function(){
    let frame = this._frame = document.createElement('div');
    frame.className = 'menu-color';
    U.setStyle(frame.style,{
     display:'block',
     position:'absolute', 
     top:this.y+'px', left:this.x+'px', width:WIDTH+'px', height:HEIGHT+'px',
     border:'solid 4px black', borderRadius:'50%',
     boxSizing:'border-box',
//     backgroundColor:'rgba(60,255,255,0.6)',
     fontSize:'96px',
     zIndex:9,
    });
    frame.innerHTML = this.icon;
    guiScreen.appendChild(frame);
    let obj = this;
    this.addHandler(frame,'mousedown',function(ev){ obj.onpush(ev); });
    this.addHandler(frame,'touchstart',function(ev){ obj.onpush(ev); });
    this.addHandler(frame,'mouseup',function(ev){ obj.onpull(ev); });
    this.addHandler(frame,'touchend',function(ev){ obj.onpull(ev); });
   };

   C.onpush = function(){ console.log('hoge'); };
   C.onpull = function(){};

   // move

   C.show = function(){
    if ( this._frame ) {
     this._frame.style.display = 'block';
    }
   };

   C.hide = function(){
    if ( this._frame ) {
     this._frame.style.display = 'none';
    }
   };

  }
   

  /////////////////////////////////////////////////////

  // CMenuDef

 /*
  # CObjectには関係ないものもはいっているので分けたほうが良いかもしれない。
  # コピーが作れないか？
 */
  {
 //  let C = Mn.CMenuDef = Mn.CObject.derive();
   let C = Mn.CMenuDef = Gui.Object.derive();


  // -> refresh
  C.initialize = function(){
   this.refresh();
  };


 // createで。
   C.refresh = function(){

    let id = this.id;
    if ( !id ) {
     M.log('a');
     throw('#6923');
    }
    if ( id.match(/\./) ) {
     M.log('b');
     throw('#8155');
    }

    let sig = this.sig? this.sig: id;
    let owner = this.owner;

    function grouping(itemListInOut){

     function subgroup(partsIdSuffix,itemList){
      let menuItems = [];
      let priorityTotal = 0;
      for( let i = 0; i < itemList.length; i++ ) {
       priorityTotal += itemList[i].priority || 1;
      }
      let j = Math.min(N_ITEMS_PER_MENU,itemList.length)-1;
      let i = itemList.length-1;
      for( ; j >= 0 && i > j; j-- ) {
       let pos1 = i+1;
       let prioritySum = 0;
       let priorityStop = priorityTotal/N_ITEMS_PER_MENU*(N_ITEMS_PER_MENU-j);
       for( ; i > j && prioritySum < priorityStop; i-- ) {
        prioritySum += itemList[i].priority;
       }
       let pos0 = i;
       menuItems[j] = subgroup(partsIdSuffix+
         '.'+(i+1),itemList.slice(pos0,pos1));
       i--;
      }
      for( ; j >= 0; j-- ) {
       menuItems[j] = itemList[j];
      }
      let menu = Mn.CMenu.create({
       partsId:id+partsIdSuffix,
       items:menuItems,
       buttonText:sig+partsIdSuffix,
       owner:owner,
      });
      itemListInOut.push(menu);
      return menu;
     }

     return subgroup('', itemListInOut.sort(function(a,b){
      return (b.priority||1) - (a.priority||1);
     }));
    }

    if ( this._itemList ) {
     let itemList = this._itemList;
     for( let i = 0; i < itemList.length; i++ ) {
      let item = itemList[i];
      if ( item.open && item.partsId ) {
       Mn.unregister(item.partsId);
      }
     }
    }
    let itemList = [];
    let i = 0;
    for( let key in this.items ) {
     let item = this.items[key];
     let partsId = id+'.'+key;
 if ( !item.setProperties ) {
  throw('#5369');
 }
     item.setProperties({menuId:id, _name:key,partsId:partsId,
      owner:owner
     });
     itemList[i++] = item;
    }
    grouping( itemList);
    for( i = 0; i < itemList.length; i++ ) {
     let item = itemList[i];
     Mn.register(item.partsId,item);
    }
    this._itemList = itemList;
   };


   C.setValues = function(arg){
    let items = this.items;
    for( let name in arg ) {
     if ( items[name] ) {
      items[name].setValue(arg[name]);
     }
    }
   };

   C.getValues = function(){
    let values = {};
    let items = this.items;
    for( let name in items ) {
     let v = items[name].getValue();
     if ( v !== undefined ) {
      values[name] = v;
     }
    }
    return values;
   };

   // よしなに
   C.correctValues = function(source){
    let result = {};
    let items = this.itmes;
    for( let name in source ) {
     if ( items[name] ) {
      items[name].correctValue(source[name]);
     }
     else {
      result[name] = source[name];
     }
    }
    return result;
   };

   C.restore = function(data){
    if ( data === undefined ) { return; }
    let items = this.items;
    for( let name in data ) {
     if ( items[name] ) {
      items[name].value = items[name].correctValue(data[name]);
     }
    }
   };


  }


  /////////////////////////////////////////////////////////////////////
  //
  // Menu Button
  //


  // CMenuButton
  {
   const C = Mn.CMenuButton = Mn.CObject.derive();
   C._className = 'MenuButton';

   C.frameTag = 'button';
 // BDWD
   C.framePadding = { top:12, bottom:12, left:32, right:32 };
   C.contentWidth = MBTN_WIDTH-32*2-2*MBTN_BDWD;
   C.contentHeight = MBTN_HEIGHT-12*2-2*MBTN_BDWD;
   C.frameClass = 'menu-button';
   C.text = '';
   C.style = {
    fontFamily: 'sans-serif', fontWeight:'bold',
    fontSize:'90px', lineHeight:'120px', textAlign:'center',
   };
   C.fitting = true;

   C.createButtonFrame = function(ap){
    let frame = this.buttonFrame = document.createElement(this.frameTag);
    frame.className = 'menu-color '+this.frameClass;
    let width = MBTN_WIDTH;
    let height = MBTN_HEIGHT;
    let style = {
     display:'block', position:'absolute',
     top:ap.y+'px', left:ap.x+'px', width:width+'px', height:height+'px',
     boxSizing:'border-box', overflow:'hidden',
//     backgroundColor:'rgba(255,255,255,0.4)',
     // border, ...
    };
    let padl = this.framePadding.left;
    let padr = this.framePadding.right;
    let cw = this.contentWidth;
    let rh = (width-cw-padl-padr)/2-MBTN_BDWD;
    padl += rh; padr += rh;
    let padt = this.framePadding.top;
    let padb = this.framePadding.bottom;
    let ch = this.contentHeight;
    let rv = (height-ch-padt-padb)/2-MBTN_BDWD;
    padt += rv; padb += rv;
    style.paddingTop    = padt+'px';
    style.paddingBottom = padb+'px';
    style.paddingLeft   = padl+'px';
    style.paddingRight  = padr+'px';
    U.setStyle(frame.style,style);
    U.setStyle(frame.style,this.style);
    this.container = document.createElement('div');
    U.setStyle(this.container.style,{
     position:'relative', width:'100%', height:'100%',
    });
    frame.appendChild(this.container);
    ap.menuLayer.appendChild(frame);
   };

   C.createButton = function(){
    return this;
   };

   C.atatchButton = function(ap){
    this._menuDepth = ap.depth;
    this.createButtonFrame(ap);
    this.setContents();
    this.setHandler();
   };

   C.detatchButton = function(){
    this._selected = false;
    this.eraseHandler();
    this.buttonFrame = undefined;
    this.container = undefined;
   };

   C.setContents = function(){
    if ( this.container ) {
     if ( this.fitting ) {
      U.fitText(this.container,this.text);
     } else {
      this.container.innerHTML = this.text;
     }
    }
   };

   C.setHandler = function(){
    this.detatch();
    this.baseElement = this.buttonFrame;
    this.atatch();
/*
    this.eraseHandler();
    if ( this.buttonFrame ) {
     if ( this.onclick ) {
      let obj = this;
      this.addHandler(this.buttonFrame,'click',function(ev){
       ev.stopPropagation();
       obj.onclick(ev)
       },false
      );
      this.addHandler(this.buttonFrame,'touchend',function(ev){
        ev.preventDefault();
        obj.onclick(ev);
       }
      ,false);
     }
    }
*/
   };

   C.hilight = function(partsId) {
    if ( this.buttonFrame ) {
     // submenu button
     if ( partsId == this.submenuId ) {
      Mn.setBackColor(this.buttonFrame,'33,150,243');
     }
     else {
      Mn.setBackColor(this.buttonFrame);
     }
    }
   };

// hilight
// lowlight
   C.buttonSelect = function(){
    this._selected = true;
    if ( this.buttonFrame ) {
     Mn.setBackColor(this.buttonFrame,'33,150,243');
    }
   };

   C.buttonDeselect = function(){
    this._selected = false;
    if ( this.buttonFrame ) {
     Mn.setBackColor(this.buttonFrame);
    }
   };


   C.buttonActive = function(){
//
    this._active = true;
    if ( this.buttonFrame ) {
     U.setStyle(this.buttonFrame.style,{ pointerEvents:'auto' });
    }
   };

   C.buttonInactive = function(){
    this._active = false;
    if ( this.buttonFrame ) {
     U.setStyle(this.buttonFrame.style,{ pointerEvents:'none' });
    }
   };

   C.isActive = function(){
    return this._active;
   };

  }


  // SubmenuButton
  {
   const C = Mn.CSubmenu = Mn.CMenuButton.derive();
   // C.menuId
   C.onclick = function(ev){
    this.buttonSelect();
 //   Mn.open(this.submenuId,ev.type=='click');
    Mn.open(this.submenuId,this._menuDepth);
   };
  }


  // CSwitch
  // MenuSwitch
  {
   const C = Mn.CSwitch = Mn.CMenuButton.derive();
   C.frameTag = 'div';
   C.default = false;
   C.frameClass = 'menu-button switch';
  
   C.setContents = function(){
    let checked = this.value? 'checked': '';
    let content = `<input type="checkbox" ${checked} />${this.text}`;
    if ( this.fitting ) {
     U.fitText(this.container,content);
    } else {
     this.container.innerHTML = content;
    }
    this.inputel = this.container.getElementsByTagName('input')[0];
   };

   C.onclick = function(){
    let checkbox = this.inputel;
    checkbox.checked = !checkbox.checked;
    this._value = checkbox.checked;
    this.onChange(this._value);
   };

/*
   C.setHandler = function(){
    this.eraseHandler();
    let obj = this;
    let checkbox = this.inputel;
    if ( checkbox ) {
     this.addHandler(this.buttonFrame,'mousedown',function(ev){
      ev.stopPropagation();
      ev.preventDefault();
     });
     this.addHandler(this.buttonFrame,'touchstart',function(ev){
      ev.stopPropagation();
      ev.preventDefault();
     });
     this.addHandler(checkbox,'click',function(ev){
      obj._value = checkbox.checked;
      obj.onChange(obj._value);
     },false);
     this.addHandler(checkbox,'touchend',function(ev){
      ev.preventDefault();
      ev.stopPropagation();
      checkbox.checked = !checkbox.checked;
      obj._value = checkbox.checked;
      obj.onChange(obj._value);
     },false);
    }
   };
*/

   C.setValue = function(value){
    this._value = !!value;
    let checkbox = this.inputel;
    if ( checkbox ) {
     checkbox.checked = !!value;
    }
   };

   C.correctValue = function(value) { return !!value; };

  }


  {
   const C = Mn.CButtonWithValue = Mn.CMenuButton.derive();

   C.setContents = function(){
    this.container.innerHTML = `<div></div><div></div>`;
    this.titleEl = this.container.firstChild;
    this.valueEl = this.titleEl.nextSibling;
    U.setStyle(this.titleEl.style,{
     position:'relative', width:'100%', height:'60px',
    });
    U.setStyle(this.valueEl.style,{
     position:'relative', width:'100%', height:'36px',
     fontFamily:'monospace', fontWeight:'normal',
    });
    U.fitText(this.titleEl,this.text);
    U.fitText(this.valueEl,U.htmlEscape(this.value));
   }

   C.setValue = function(value){
    this._value = value;
    if ( this.valueEl ) {
     U.fitText( this.valueEl, U.htmlEscape(value) );
    }
   }

  }


  ///////////////////////////////////////////////////////////////////////


// SlideMenuLayer

  // Mn.CParts
  {
   let C = Mn.CParts = Mn.CObject.derive();

 //createMenuLayer()

   // createButton

   C.open = function(depth){
    this._menuDepth = depth;
   };
   
   C.createMenuLayer = function(){
 //   this._menuDepth = depth;

 let depth = this._menuDepth;

    let layer = this._menuLayer = document.createElement('div');
    layer.className = 'menu-layer';
    menuFrame.appendChild(layer);
    let x = depth > 0? menuWidth[depth-1]: MENU_MAX_WIDTH;
    let y = 0;
    let height = MENU_HEIGHT;
    let width = MENU_MAX_WIDTH;
    U.setStyle(layer.style,{
     position:'absolute',
     top: y+'px', left: x+'px', width:width+'px', height:height+'px',
//border:'solid 1px red',
     opacity:1,
    });

    let inner = this._menu


    setMenuWidth(width);
    this._menuActive = true;

    let obj = this;

    if ( this.onmenulayerclick ) {
     this.addHandler(layer,'mouseup',function(ev){
      obj.onmenulayerclick(ev);
     },true);
     this.addHandler(layer,'touchend',function(ev){
      obj.onmenulayerclick(ev);
     },true);
    }

 /*
    this.addHandler(layer,'mouseenter',function(ev){
     obj.onmenulayermouseenter(ev);
    },true);
    */

   };

   C.setMenuWidth = function(width){
    if ( width > MENU_MAX_WIDTH ) {
     throw('#2951');
    }
    U.setStyle(this._menuLayer.style,{ width: width+'px', });
    setMenuWidth(width);
   };

   // catched
   C.unusedmouseevent = function(ev){
     ev.preventDefault();
     ev.stopPropagation();
   };

   //
   C.activate = function(transition){


// _menuActive不要?
    this._menuActive = true;
    if ( this._menuLayer ) {
     U.setStyle(this._menuLayer.style,{
      transitionDuration:transition? '0.2s': '0s',
      opacity:1,
//      pointerEvents:'auto'
     });
    }
    if ( this.owner && this.owner.onMenuActive ) {
     this.owner.onMenuActive();
    }
   };

   C.inactivate = function(transition){
    this._menuActive = false;
    if ( this._menuLayer ) {
     U.setStyle(this._menuLayer.style,{
      opacity:0,
//     pointerEvents:'none',
      transitionDuration:transition? '0.2s': '0s',
     });
    }
    if ( this.owner && this.owner.onMenuInactive ) {
     this.owner.onMenuInactive();
    }
   };

   C.close = function(){
    this.eraseHandler();
    this._menuActive = false;
    let layer = this._menuLayer;
    if ( layer ) {
     U.setStyle(this._menuLayer.style,{ opacity:0, pointerEvents:'none' });
     setTimeout(function(){ 
      menuFrame.removeChild(layer);
     },500);
     this._menuLayer = undefined;
    };
    if ( this.onclose ) {
     this.onclose();
    }
   };


   C.setButtonHandler = function(){
    if ( this._button ) {
     let obj = this;
     this._button.setProperties({
      onclick:function(ev){
       obj.buttonSelect();
       obj.onbuttonclick(ev);
      }
     });
    }
   }

 // 
   C.onbuttonclick = function(ev){

//    Mn.open(this.partsId,this._menuDepth);
    Mn.open(this.partsId,this._button._menuDepth);

   };

   C.onreturn = function(){};

   C.buttonSelect = function(){
    if ( this._button ) {
     this._button.buttonSelect();
    }
   };

   C.buttonDeselect = function(){
    if ( this._button ) {
     this._button.buttonDeselect();
    }
   };


  }


  // CMenu
  {
   let C = Mn.CMenu = Mn.CParts.derive();
   C.buttonText = '?';
   C.frameClass = 'menu';

   C.refresh = function(){
    this.buttons = [];
    for( let i = 0; i < this.items.length; i++ ) {
     this.buttons[i] = this.items[i].createButton();
    }
   };


   C.createButton = function(){
    if ( !this._button ) {
     this._button = Mn.CSubmenu.create();
    }
    this._button.setProperties({
     text:this.buttonText,
     submenuId: this.partsId,
 // menuId
 // ownerId
 // groupId
 // menuGroupId
    });
    return this._button;
   };


   C.open = function(depth){
    this._menuDepth = depth;

    if ( this._menuLayer ) {
     // 2重には開けないエラー
     // どれも
     throw('#1583');
    }
 // 一つに
    this.createMenuLayer();
    this.setMenuWidth(MBTN_WIDTH+2*MBTN_MGNH);
    let layer = this._menuLayer;
    for( let i = 0; i < this.buttons.length; i++ ) {
     let x = MBTN_MGNH; let y = i*(MBTN_HEIGHT+MBTN_MGNV)+MBTN_MGNV;
     this.buttons[i].atatchButton({menuLayer:layer,depth:depth+1,x:x,y:y});
    }
   };

   C.close = function(){
    if ( this.buttons ) {
     for( let i = 0; i < this.buttons.length; i++ ) {
      this.buttons[i].detatchButton();
     }
    }
    C._super.close.call(this);
   };

   C.hilight = function(partsId){
    for( let i = 0; i < this.buttons.length; i++ ) {
     if ( this.buttons[i].hilight ) {
      this.buttons[i].hilight(partsId);
     }
    }
   };

   C.onreturn = function(ev){
    for( let i = 0; i < this.buttons.length; i++ ) {
     if ( this.buttons[i].buttonDeselect ) {
      this.buttons[i].buttonDeselect();
     }
    }
   };

   C.activate = function(transition){
    for( let i = 0; i < this.buttons.length; i++ ) {
     if ( this.buttons[i].buttonActive ) {
      this.buttons[i].buttonActive(transition);
     }
    }
    C._super.activate.call(this,transition);
   };

   C.inactivate = function(transition){
    for( let i = 0; i < this.buttons.length; i++ ) {
     if ( this.buttons[i].buttonInactive ) {
      this.buttons[i].buttonInactive(transition);
     }
    }
    C._super.inactivate.call(this,transition);
   };

  }


   
  // CSlider
  {
   const C = Mn.CSlider = Mn.CParts.derive();
   C.min = 0;
   C.max = 1;
   C.default = 0;
   C.curve = 'linear';
   C.title = '';
   C.unit = '';
   C.frameClass = 'menu slider';
    // menu?

   const SLIDER_RANGE = 1000;
    // SCALE


//atatchで入れていた
   C.createButton = function(){
    this._button = Mn.CButtonWithValue.create({
      text:this.buttonText? this.buttonText: this.title,
      submenuId:this.partsId,
    });
    this.setButtonHandler();
    this.setTitle();
    this._button.value = this.value;
    return this._button;
   };

   // open
   C.open = function(depth){
    this._menuDepth = depth;

    const padv = 20;

    this.createMenuLayer();

 const WIDTH = 150;
    this.setMenuWidth(WIDTH+2*padv);

    let frame = this._frame = document.createElement('div');
    frame.className = 'menu-color '+this.frameClass;
    U.setStyle(frame.style,{
     display:'block',
     position:'absolute',
     top: 0, right: (WIDTH+padv)+'px',
     width:MENU_HEIGHT+'px', height:WIDTH+'px',
     transformOrigin:'top right',
     transform:'rotate(-90deg)',
     boxSizing:'border-box',
     borderStyle:'solid', borderWidth:'4px',
     borderRadius:'112px',
    });
    this._menuLayer.appendChild(frame);
    let div1 = document.createElement('div');
    U.setStyle(div1.style,{
     position:'absolute',
     left:0, width:'60%', top:'0', bottom:'0',
     boxSizing:'border-box',
    });
    frame.appendChild(div1);
    let div2 = document.createElement('div');
    U.setStyle(div2.style,{
     position:'absolute',
     right:0, width:'40%', top:'0', bottom:'0',
     boxSizing:'border-box',
    });
    frame.appendChild(div2);
    this._titlebox = document.createElement('div');;
    U.setStyle(this._titlebox.style,{
     position: 'absolute',
     top: '12px', bottom:'12px',
     left: '32px', right:'12px',
     boxSizing:'border-box',
     opacity:0.6,
    });
    div1.appendChild(this._titlebox);
    this._valuebox = document.createElement('div');;
    U.setStyle(this._valuebox.style,{
     position: 'absolute',
     top: '12px', bottom:'12px',
     left: '12px', right:'32px',
     boxSizing:'border-box',
     fontFamily: 'monospace', fontWeight: 'normal',
     textAlign: 'right',
     opacity:0.6,
    });
    div2.appendChild(this._valuebox);

    let obj = this;

    this._input = Gui.Slider.create({
     boxEl:frame, frameStyle:undefined,
     min: 0, max: SLIDER_RANGE,

     oninput: function() {
      let linearValue = this.value;
      let value;
      if ( obj.curve == 'log' ) {
       value = Math.exp( (Math.log(obj.max) - Math.log(obj.min))
        *(linearValue/SLIDER_RANGE) + Math.log(obj.min)
       );
      } else {  // linear
       value = linearValue/SLIDER_RANGE*(obj.max-obj.min) + obj.min;
      }
      obj._setValue(value);
      obj.onChange(value);
     }
    });
    this._input.open();

    U.fitText(this._valuebox,'1234.5'+this.unit);
    // set callback
    this.setTitle();
    this.setValue(this.value);

//    this._input.focus();
   };

   C.close = function(){
    this._frame = undefined;
    this._titlebox = undefined;
    this._valuebox = undefined;
    if ( this._input ) {
     this._input.close();
    }
    this._input = undefined;
    C._super.close.call(this);
   };

   C.setTitle = function(){
    if ( this._titlebox ) {
     U.fitText(this._titlebox,this.title);
    }
   };

   C.setValueText = function(){
    let text;
    if ( this.curve == 'log' ) {
     text = U.roundRelative(this._value,3);
    } else {
     text = U.roundFixed(this._value,1);
    }
    text += this.unit;
    if ( this._valuebox ) {
     this._valuebox.firstChild.innerHTML = text;
    }
    this._button.value = text;
   };

   C.setValue = function(value){
    this._value = value;
    this.setValueText();
    let slider = this._input;
    if ( slider ) {
     let sval;
     if ( this.curve == 'log' ) {
      sval = (Math.log(value)-Math.log(this.min))
       /(Math.log(this.max)-Math.log(this.min))*SLIDER_RANGE;
     } else {
      sval = (value-this.min)/(this.max-this.min)*SLIDER_RANGE;
     }
     slider.value = sval;
    }
   };

   C._setValue = function(value){
    this._value = value;
    this.setValueText();
   };
   
   C.correctValue = function(value){
    return U.correctNumber(value,this.min,this.max,this.default);
   };

  }

 // 
 /*
 //   this.createFrame(MENU_MAX_WIDTH);
    this.createMenuLayer(depth);
 // width optionで
    let frame = this._frame = document.createElement('div');
    frame.className = this.frameClass;
    const PADH = 24;
 const PADV = 12;
    U.setStyle(frame.style,{
     position:'absolute',
     left:0, top:0, right:0, height:MBTN_HEIGHT+'px',
     padding: `${PADV}px ${PADH}px`,
     boxSizing:'border-box',
    });
    this._menuLayer.appendChild(frame);
 */

  // CText
  {
   const C = Mn.CText = Mn.CParts.derive();
   C.default = '';
   C.title = '';
   C.frameClass = 'menu text';
   C.historyKey = 'text';

   const fontSize = 28;
   const lineHeight = 40;

   C.minHeight = 12;

   C.createButton = function(){
    this._button = Mn.CButtonWithValue.create({
      text:this.buttonText? this.buttonText: this.title,
    });
    this._button.value = this.value;
    this.setButtonHandler();
    return this._button;
   };

   C.open = function(depth){
    this._menuDepth = depth;

    let frameEl = this.frameEl = document.createElement('div');
    frameEl.className = 'menu-color';
    U.setStyle(frameEl.style,{
     position:'relative',
     boxSizing:'border-box',
    });

    modalScreen.appendChild(frameEl);

    frameEl.innerHTML = `<span><input type="text" /></span><span>${Icon.close(lineHeight+'px','menu-color-svg')}</span><div></div>`;
    let outerEl = frameEl.firstChild;
    let inputEl = this.inputEl = outerEl.firstChild;
    U.setStyle(outerEl.style,{
     position:'absolute',
     top:0, left:0, right:lineHeight+'px', height: lineHeight+'px',
    });
    if ( this.placeholder ) {
     inputEl.placeholder = this.placeholder;
    }
    U.setStyle(inputEl.style,{
//     width:'100%',
     width:'100%',
     height:'100%',
     fontSize: fontSize+'px',
     lineHeight:fontSize+'px',
//     height:lineHeight+'px',
     boxSizing:'border-box',
// フォント
//     zIndex:1,
    });

    let obj = this;

    let closeEl = outerEl.nextSibling;
    U.setStyle(closeEl.style,{
      position:'absolute',
      top:0, right:0, width:lineHeight+'px', height:lineHeight+'px',
    });
    this.addHandler(closeEl,'click',function(ev){
      obj.inputEl.blur();
      obj._onchange();
    });

    let listEl = closeEl.nextSibling;
    U.setStyle(listEl.style,{
     position:'absolute',
     width:'100%', 
     top:lineHeight+'px', bottom:0,
    });

    this._listBox = Gui.Select.create({
     boxEl: listEl,
     oninput: function(){
      obj.setValue(obj._listBox.value);
//      obj.onChange(obj._value);
      obj._onchange();
     },
     list:M.getInputHistory(this.historyKey),
    });
    this._listBox.open();


    U.setStyle(modalScreen.style,{ display:'block', });


    //
    this.addHandler(inputEl,'input',function(ev){ obj._oninput(ev); });
    this.addHandler(inputEl,'change',function(ev){
     obj.inputEl.blur();
     obj._onchange();
    });
    this.addHandler(inputEl,'keydown',function(ev){
     if ( ev.keyCode == 27 || ev.keyCode == 9 ) { // escape, tab,
      obj.inputEl.blur();
      obj._onchange();
     }
    });

 // myou
    this.setValue(this.value);
    this.onresize();
    this.inputEl.focus();
    textInputMode = 1;

    
 //
   };

   // オプションでも可能に!
   // catchInputEvent オプション...
   C._oninput = function(ev){
    // hyouji demo yatta houga iino?
    this.inputEl.dir = Opt.textDirection == 'auto'
     ? (U.isArabic(this.inputEl.value)? 'rtl': 'ltr')
     : Opt.textDirection;
    this._setValue(this.inputEl.value);
//    this.onChange(this._value);
   };

   C.close = function(){
    C._super.close.call(this);
    textInputMode = 0;
    if ( this._listBox ) {
     this._listBox.close();
     this._listBox = undefined;
    }
    if ( this.frameEl ) {
     modalScreen.removeChild(this.frameEl);
        // removeChildしたときに、onchangeが発生する...
        // 先にハンドラを消すか
     U.setStyle(modalScreen.style,{
      display:'none',
     });
    }
    this.frameEl = 
    this.inputEl = undefined;
   };


   C.onresize = function(){
    if ( this.frameEl ) {
     let ww = modalScreen.clientWidth;
     let wh = modalScreen.clientHeight;
     const maxWidth = 720;
//     const maxHeight = 48;
     const maxHeight = 400;
     let boxw = Math.min(ww,maxWidth);
     let boxh = Math.min(wh,maxHeight);
     let x = (ww-boxw)/2;
     let y = (wh-boxh)/2;
 //y = 0;
     U.setStyle(this.frameEl.style,{
      left:x+'px',
 //     top:y +'px',
      width:boxw+'px', height:boxh+'px',
     });
    }
   };

   C._onchange = function(){
    this.onChange(this._value);

    // oninputが渡っている..
// focusout時に呼ばれる
    M.setInputHistory(this.historyKey,this._value);
    Mn.back(this._menuDepth-1);
   };

   C.setValueText = function(){
    if ( this._button ) { this._button.value = this._value; }
   };

   C.setValue = function(value){
    this._value = value;
    this.setValueText();
    if ( this.inputEl ) {
     this.inputEl.value = value;
     this.inputEl.dir = U.isArabic(this.inputEl.value)? 'rtl': 'ltr';
    }
   };

   C._setValue = function(value){
    this._value = value;
    this.setValueText();
   };
   
  }


  // CSelect
  {
   const C = Mn.CSelect = Mn.CParts.derive();

   C.default = '';

   C.frameClass = 'menu';

   C.cellHeight = 90;
   C.fontSize = '56px';
   C.lineHeight = '74px';
   C.cellPadH = 16;  // 単位... 
   C.cellPadV = 8;   //
   C.autoWidth = true;
   C.whiteSpace = 'nowrap';
   C.list = [];


   C.createButton = function(){
    this._button = Mn.CButtonWithValue.create({
     text:this.buttonText? this.buttonText: this.title,
    });
    this.setButtonHandler();
    this.setValue(this.value);
    return this._button;
   };

   C.open = function(depth){
    this._menuDepth = depth;
    this.createMenuLayer();
    let frame = this._frame = document.createElement('div');
    frame.className = 'menu-color '+this.frameClass;
    const PADH = 24;
    U.setStyle(frame.style,{
     position:'absolute',
     top:0, left:0, width:'100%', height:'100%',
     boxSizing:'border-box',
    });
    if ( this.autoWidth ) {
     U.setStyle(frame.style,{
      display:'inline-block',
      width:'auto',
     });
    }
    this._menuLayer.appendChild(frame);
    let obj = this;
    this._input = Gui.Select.create({
     boxEl:frame,
     cellHeight:this.cellHeight,
     fontSize:this.fontSize, lineHeight:this.lineHeight,
     cellPadV:this.cellPadV, cellPadH:this.cellPadH,
     autoWidth:this.autoWidth,
     whiteSpace:this.whiteSpace,
     style:{ maxWidth:Mn.menuMaxWidth()+'px' },
     list:this.list,
     oninput: function(){ obj._oninput(this.value); },
    });
    this.setValue(this.value);
    this._input.open();
    this.setMenuWidth(this._frame.clientWidth);
   };

   C.close = function(){
    this._frame = undefined;
    if ( this._input ) {
     this._input.close(); this._input = undefined;
    }
    C._super.close.call(this);
   };

   C._oninput = function(value){
    this._setValue(value);
    this.onChange(value);
    Mn.back();
   };

   C.setValueText = function(){
    if ( this._button ) {
     let text = '';
     for( let i = 0; i < this.list.length; i++ ) {
      let item = this.list[i];
      if( this._value == (typeof(item) == 'object'?
        (item.value !== undefined? item.value: item[0]): item) ) {
       text = typeof(item) == 'object'
        ? (item.text !== undefined? item.text:
          (item.value !== undefined? item.value:
          item[1]))
        : item;
       break;
      }
     }
     this._button.value = text;
    }
   };

   C.setValue = function(value){
    this._value = value;
    this.setValueText();
    if ( this._input ) {
     this._input.value = value;
    }
   };

   C._setValue = function(value){
    this._value = value;
    this.setValueText();
   };
   
  }


  /*
   CTransform
   move, resize, rotate
  */
  {
   let C = Mn.CTransform = Mn.CParts.derive();
   C._className = 'Transform';

 // scale
 //  C.default = { x:0, y: 0, zoom:1, rotation:0 },

   C.x      = { min: -0.5, max: 0.5, default:0 };
   C.y      = { min: -0.5, max: 0.5, default:0 };
 //  C.zoom   = { min: 1/16, max: 16, default:1, enable:false };
 //  C.rotation = { default:0, enable:false };


   C.buttonText = 'Transform';
   C.frameClass = 'menu position';
    // 使ってない？


// どっちみち使えない
// 何もしない方向で。
   C.toInternalCoordinate = function(pos){
    return{
     x:(pos.x - M.pRect.width/2) / M.cRect.diagonal,
     y:(pos.y - M.pRect.height/2) / M.cRect.diagonal
    };
   };


   C.createButton = function(){
    this._button = Mn.CMenuButton.create({
      text:this.buttonText,
    });
    this.setButtonHandler();
    return this._button;
   };

   C.open = function(depth){
    this._menuDepth = depth;
    Mn.inactive();
//    Mn.dispSideButtons(['back']);

    let screen = this._screen = document.createElement('div');
    U.setStyle(screen.style,{
     position:'absolute',
     top:0, bottom:0, left:0, right:0,
     zIndex:6, // メニューより上
    });
    guiScreen.appendChild(screen);

// atatch(screen);
    this.baseElement = screen;
    this.atatch();

    // 他も...
    if ( this.onopen ) {
     this.onopen();
    }
   };

   C.close = function(){
    // 閉じてからか?
    if ( this.onclose ) {
     this.onclose();
    }
    if ( this._screen ) {
     guiScreen.removeChild(this._screen);
      /* this._screen.parentElement.removeChild(this._screen); */
    }
    Mn.active();
    Mn.dispSideButtons();
    C._super.close.call(this);
   };

   C.onclick = function(){
    Mn.back();
   };

   C.ontouch1start = function(ti){
    this.startTi = ti;
    this.prevTi = ti;
    this.startValue = this.value;
    if ( this.ontransformstart ) { this.ontransformstart(); }
   };

   C.ontouch1move = function(newTi){
    let value = Object.assign({},this.value);
    let zoomDelta = 1;
    let rotationDelta = 0;
    let oldPos = this.startTi.pos[0];
    let newPos = newTi.pos[0];


// 一つ前!
let ti0 = this.prevTi;
let ti1 = newTi;
let dist = U.dist(ti1.pos[0].x-ti0.pos[0].x, ti1.pos[0].y-ti0.pos[0].y);
let dt = (ti1.time - ti0.time)/1000;
    this.prevTi = newTi;

    this._change(this.startValue,oldPos,newPos,zoomDelta,rotationDelta);
   };

   C.ontouch1end = function(ti){
    // transform
    if ( this.ontransformend ) {
     this.ontransformend();
    }
   };

   C.ontouch2start = function(ti){
    this.startTi = ti;
    this.startValue = this.value;
   };

   C.ontouch2move = function(newTi){
    let value = Object.assign({},this.value);
    let zoomDelta = this.zoom? newTi.distance/this.startTi.distance: 1;
       // startGi.distance0にはしないで
    let rotationDelta =
     this.rotation? (newTi.angle-this.startTi.angle)/(2*Math.PI): 0;
    let oldPos = this.startTi.center;
    let newPos = newTi.center;
    this._change(this.startValue,oldPos,newPos,zoomDelta,rotationDelta);
   };

   C.ontouch2end = function(ti){
   };

   C.onwheel = function(wi){
    let zoomDelta = 1;
    let rotationDelta = 0;
    let modifierKey = wi.altKey || wi.ctrlKey || wi.metaKey;
    if ( this.rotation ) {
     rotationDelta = modifierKey? wi.deltaY: wi.deltaX;
    }
    if ( this.zoom ) {
     let delta =modifierKey? wi.deltaX: wi.deltaY;
      // 
     zoomDelta =
       Math.exp(-delta*(Math.log(this.zoom.max)-Math.log(this.zoom.min)));
    }
    this._change(this.value,wi.pos,wi.pos,zoomDelta,rotationDelta);
   };

   C._change = function(oldValue,oldPos,newPos,zoomDelta,rotationDelta){
    let rotation = 0;
    let zoom = 1;
    if ( this.rotation ) {
     rotation = oldValue.rotation + rotationDelta;
    }
    if ( this.zoom ) {
     zoom = oldValue.zoom * zoomDelta;
     if ( zoom > this.zoom.max ) { zoom = this.zoom.max; }
     if ( zoom < this.zoom.min ) { zoom = this.zoom.min; }
     zoomDelta = zoom/oldValue.zoom;
    }
    if ( newPos.x != oldPos.x || newPos.y != oldPos.y ||
      rotationDelta != 0 || zoomDelta != 1 ) {
     let value = Object.assign({},oldValue);
     let t = 2*Math.PI*rotationDelta;
     let x0 = zoomDelta*(value.x - oldPos.x);
     let y0 = zoomDelta*(value.y - oldPos.y);
     value.x = x0*Math.cos(t) - y0*Math.sin(t) + newPos.x;
     value.y = x0*Math.sin(t) + y0*Math.cos(t) + newPos.y;
     if ( this.rotation ) { value.rotation = rotation; }
     if ( this.zoom ) { value.zoom = zoom; }
     this._value = value;
     this.onChange(value);
    }
   };

   C.getValue = function(){
    if ( this._value === undefined ) {
     let v = { x:this.x.default, y:this.y.default };
     if ( this.zoom ) { v.zoom = this.zoom.default; }
     if ( this.rotation ) { v.rotation = this.rotation.default; }
     this._value = v;
    }
    return this._value;
   };

   C.setValue = function(value){
    this._value = Object.assign({},value);
   };

   C.correctValue = function(value){
    let v = {
     x: U.correctNumber(value.x,this.x.min,this.x.max,this.x.default),
     y: U.correctNumber(value.y,this.y.min,this.y.max,this.y.default),
    };
    if ( this.zoom ) {
     v.zoom = U.correctNumber(value.zoom,this.zoom.min,
      this.zoom.max,this.zoom.default);
    }
    if ( this.rotation ) {
     v.rotation = U.correctNumber(value.rotation,this.rotation.min,
      this.rotation.max,this.rotation.default);
    }
    return v;
   };
   
  }



 /////////////////////////////////////////////////////////////////////



 // Mp
  Mn.button = function(opt){
   return Mn.CMenuButton.create(opt);
  };


  {
   let C = Mn.CIconSwitch = Mn.CSwitch.derive();
   C.style = {};
   C.contentWidth = 76;
   C.contentHeight = 76;
   C.fitting = false;
  }

  {
   let C = Mn.CIconButton = Mn.CMenuButton.derive();
   C.fitting = false;
   C.contentWidth = ICON_SIZE+'px',
   C.contentHeight = ICON_SIZE+'px';
  }


 // true/1?
  Mn.visibilitySwitch = function(p){
   const D = 64;
   let padv = (MBTN_HEIGHT-D)/2-MBTN_BDWD;
   let padh = 24;
   return Mn.CSwitch.create({fitting:false,
    default:true,
    frameClass:'menu-button slidesw',
    style:{fontFamily:'monospace'},
 //   framePadding:{ top:padv, bottom:padv, left:padh, right:padh },

 // contentWidth,Heightを設定しないとだめなしようじゃん！！
 // 再検討
    contentWidth:MBTN_WIDTH-48-2*MBTN_BDWD,
    contentHeight:D,
    text:`<div class="slidesw-knob menu-color" style="position: absolute;
     height: ${D}px; width: ${D}px; left: 0px; bottom: 0px;
     border-style:solid; border-width:4px;
     box-sizing:border-box;
     border-radius: 50%;"></div>`,
   },p);
  };


  Mn.italicSwitch = function(p){
   return Mn.CIconSwitch.create({
    style:{
     fontFamily:'serif', fontWeight:'bold',
     fontSize:'76px', lineHeight:'76px', textAlign:'center',
    },
    text:`<div class="italicsw">I</div>`
   },p);
  };


 //
  Mn.barOrientation = function(p){
   return Mn.CIconSwitch.create({
    frameClass:'menu-button rotary90',
    text:`${Icon.barHoriz('100%','100%')}`,
   },p);
  }


 // icon専用の部品を!!

 // textはsvg iconにする。
  Mn.bwColor = function(p){
   let text = Icon.invColorOff('100%');
   return Mn.CIconSwitch.create({
    text:`<div class="bwcolorsw" style="height:100%">${text}</div>`
   },p);
  };

/*
  // なんかsvgが少しずれる
  Mn.translucentMaskSw = function(p){
   let onText = Icon.maskTranslucent(ICON_SIZE);
   let offText = Icon.maskOpaque(ICON_SIZE);
   let padh = (MBTN_WIDTH-ICON_SIZE)/2 - MBTN_BDWD;
   let padv = (MBTN_HEIGHT-ICON_SIZE)/2 - MBTN_BDWD;
   return Mn.CSwitch.create({
    style:{
     padding:`${padv}px ${padh}px`,
    },
    fitting:false,
    text:`<div class="alternatesw" 
     ><div class="on">${onText}</div>
     <div class="off">${offText}</div>
     </div>`
   },p);
  };
*/

  Mn.translucentMaskSw = function(p){
   let mask = Icon.mask(ICON_SIZE);
   return Mn.CIconSwitch.create({
    text:`<div>
      <div style="position:absolute; top:0; bottom:0; left:0; right:0;
       font-size:24px; line-height:${ICON_SIZE}px; text-align:center">mask</div>
      <div style="position:absolute; top:0; bottom:0; left:0; right:0;"
        class="masksw">${mask}</div>
     </div>`
   },p);
  };


  Mn.rotate90 = function(p){
   return Mn.CMenuButton.create({
    fitting:false,
    contentWidth: ICON_SIZE+'px',
    contentHeight: ICON_SIZE+'px',
    text: Icon.rotate90('100%'),
   },p);
  }

  Mn.rotate270 = function(p){
   return Mn.CMenuButton.create({
    fitting:false,
    contentWidth: ICON_SIZE+'px',
    contentHeight: ICON_SIZE+'px',
    text: Icon.rotate270('100%'),
   },p);
  }



  Mn.opacity = function(p){
   return Mn.CSlider.create({
    title:'Opacity', curve:'linear',
    min:0, max:100, default:20, unit:'%',
   },p);
  };


  // ボタン表示のときにやらないと...
  {
   let C = Mn.CFont = Mn.CSelect.derive();
   C.buttonText  = `<span style="font-family:cursive;">Font</span>`;
   C.title       = 'Font Family';
   C.default     = 'sans-serif';
   C.cellHeight  = 160;
   C.lineHeight  = '0px';
   C.cellPadH    = 20;
   C.cellPadV    = 0;
   C.autoWidth   = false;
   C.list        = [];
   C.sampleText  = "Sample Text";

   C.createButton = function(){
    this.list = M.presetFonts;
    return C._super.createButton.call(this);
   };

   C.open = function(depth){
    let list = [];
 // loadFont
    for( let i = 0; i < M.presetFonts.length; i++ ) {
     let fontName = M.presetFonts[i];
     let fontFamily = fontName.match(/^[a-z]/)? fontName: `'${fontName}'`;
     let text = this.sampleText;
     let cellText = `
      <div style="font-size:24px;line-height:32px;height:40px;text-align:right;border-top:solid 1px #ccc">${fontName}</div
       ><div style="font-family:${fontFamily}; font-size:90px;line-height:120px;">${text}</div>
     `;
     list[i] = { value:fontName, htmlText:cellText };
    }
    this.list = list;
    C._super.open.call(this,depth);
   };

  };

  Mn.font = function(p){ return Mn.CFont.create(p) };

  const FONT_WEIGHT_LIST = [
   [ 1, '1 Thin'         ],
   [ 2, '2 Extra Light'  ],
   [ 3, '3 Light'        ],
   [ 4, '4 Normal'       ],
   [ 5, '5 Medium'       ],
   [ 6, '6 Semi Bold'    ],
   [ 7, '7 Bold'         ],
   [ 8, '8 Extra Bold'   ],
   [ 9, '9 Black'        ],
  ];

  Mn.fontWeight = function(p){
   return Mn.CSelect.create({
    title:'Font Weight', default:4,
    list:FONT_WEIGHT_LIST,
   },p);
  };



 });
})();
