/*

 loaderとconsoleは古いブラウザでも実行できるようにしないと
 エラーを出せない。

  let,
  ``
-> ClosureCompiler使うので不要になった。
  let, const, ` 使ってもいいぞ。


 {
  const Ld = sLoader;
  Ld.module('main',function(){
   this.body = {};                    // enable backword reference
   const M = this.body;
   const N = Ld.use('module-name');
   M.hoge = function(){};
  });
 }

 *OR*

 {
  const Ld = sLoader;
  Ld.module('uhyo',function(){
   const N = {};
   const M = Ld.ref('main');          // backword reference
   const U = Ld.use('utitility');
   N.hoge = ...
   return N;                          // this.body = N
  }
 }

*/

var sLoader = {};

(function(){
 'use strict';

//  どうしよ。
// DEBUGモードではwarnで死ぬようにしたい。
//

var DEBUG=1;

 var Ld = sLoader;

// mainか?
// build.js
 // install.pl
 Ld.appDebug = 1;
 Ld.appVersion = '__VERSION__';

 var modules = {};

 modules.main = { name: 'main', body: {} };

 // kansuu ni suruto mobile Safari de ugokanai.
 // Why??
 // {}が思っているのと違うのかな...
 Ld.warn = function( /* arguments */ ){
  if ( modules['console'] ) {
   var cons = modules['console'].body;
   if ( cons ) {
    cons.error.apply(cons,arguments);
   }
  }
 };

 Ld._log = function( /* arguments */ ) {
  if ( modules['console'] ) {
   var cons = modules['console'].body;
   if ( cons ) {
    cons.log.apply(cons,arguments);
   }
  }
 };

 Ld.die = function(/*arguments*/){
  Ld.warn.apply(this,arguments);
  Ld.aborted = true;
  throw('fatal');
 };


 // すぐに処理することにした
 Ld.module = function(name,loader){
  if( Ld.aborted ) return;
  let module = modules[name];
  if ( module ) {
   if ( module.status ) {
    Ld.die('module name "'+(name)+'" already used');
   }
  } else {
   module = modules[name] = { name: name };
  }
  var body;
  Ld._log('loading "'+(name)+'"');
  try{
   body = loader.call(module);
  }
  catch(e){
   var message = '';
   if ( typeof e === 'string' ) {
    message = e;
   } else {
    if ( e.message ) { message += e.message+'\n'; }
    if ( e.stack ) { message += e.stack; }
    if ( message == '' ) {
     message = e.toString();
    }
   }
   if ( message ) {
    console.trace();
    console.log(message);
    Ld.die(message);
   }
  }
  finally{
   module.status = 'completed';
  }
  if ( body ) {
   module.body = body;
  }
  if ( !module.body ) {
   Ld.die('module "'+(name)+'" body undefined');
  }
 };


 Ld.ref = function(name){
  if ( Ld.aborted ) { throw('fatal'); }
  var module = modules[name];
  if ( !module ) {
   Ld.die('module "'+(name)+'" unregisterd');
  }
  if ( !module.body ) {
   Ld.die('module "'+(name)+'" not loaded');
  }
  return module.body;
 };


 Ld.use = function(name){
  if ( Ld.aborted ) { throw('fatal'); }
  var module = modules[name];
  if ( !module ) {
   Ld.die('module "'+(name)+'" not loaded');
  }
  if ( !module.body ) {
   throw('fatal');
  }
  return module.body;
 };


 // addEventListener wa damemitai. 
 // ファイルを分割しているとうまくいかない。
 window.onerror = function(msg, source, lineno, colno, error){
  Ld.warn(''+(lineno)+':'+(colno)+': '+(msg)+'');
 };


 window.addEventListener('load',function(){
  Ld.use('main').main();
 },false);

})();

