(function(){
 'use strict';

 const Ld = sLoader;
 sLoader.module('view',function(){

  const Gui = Ld.use('gui-object');
  const View = Gui.Object.derive();

  const M = Ld.ref('main');
  const Mp = Ld.use('mainParam');
  const Mn = Ld.use('menu');
  const U  = Ld.use('utility');


  // 一意に割り当てないといけないので
  // 指定していないときはエラーにしたほうがよいか
  View.menuId = 'view';


  View.initialize = function(){
   //
   let obj = this;
   this.menu = Mn.CTransform.create({
    owner:this,
    name:'transform',
    zoom:{ min:1, max:8, default:1 },
    toInternalCoordinate:function(pos){
     let panediagonal = U.dist(M.paneEl.clientWidth,M.paneEl.clientHeight);
     return{
      x:(pos.x-M.pRect.width/2) / M.screenScale,
      y:(pos.y-M.pRect.height/2) / M.screenScale
     };
    },
    onopen: function(){ obj.open(); },
    onclose:function(){ obj.close(); },
   });
   Mn.register(this.menuId, this.menu );
  };


  View.open = function(){
   this.menu.value = {
    x: Mp.view.x,
    y: Mp.view.y,
    zoom: Mp.view.scale
   };
   Mp.view.mode = 'preview';
   Mp.view.magnification = 'free';
  };


  View.close = function(){
   Mp.view.mode = 'edit';
  };


  View.onChange = function(data){
   Mp.view.x = data.transform.x;
   Mp.view.y = data.transform.y;
   Mp.view.scale = data.transform.zoom;
   M.adjustScale();
  };


  View.change = function(){
   this.menu.value = {
    x: Mp.view.x,
    y: Mp.view.y,
    zoom: Mp.view.scale
   };
  }


  return View;

 });

})();
